/*
 *  Copyright (c) 2004-2013 Mellanox Technologies LTD. All rights reserved
 *
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */


#ifndef _IBDIAGNET_PLUGINS_H_
#define _IBDIAGNET_PLUGINS_H_


#include <stdlib.h>

#include <infiniband/ibdiag/ibdiagnet/ibdiagnet_plugins_ifc.h>

/******************************************************/
/* new types */
typedef struct symbols_plugin {
    string library_file_name;
    void *p_library_obj;
    create_plugin_t *create_func;
    destroy_plugin_t *destroy_func;
    Plugin *p_plugin_obj;
} symbols_plugin_t;

typedef list <symbols_plugin_t *> list_p_symbols_plugin;


/******************************************************/
string get_plugins_paths_str();
string get_plugin_path_str(IN string plugin_name);
int get_plugins_names(OUT list_str& names,
        OUT string& errors);
symbols_plugin_t * load_plugin(IN string plugin_name,
        IN IBDiag *p_ibdiag,
        OUT string& errors);
void unload_plugin(IN symbols_plugin_t *p_plugin_symbols);

#endif          /* not defined _IBDIAGNET_PLUGINS_H_ */
