/*
 * Copyright (c) 2004-2015 Mellanox Technologies LTD. All rights reserved.
 *
 * This software is available to you under the terms of the
 * OpenIB.org BSD license included below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

#ifndef _PHY_DIAG_ERRS_H_
#define _PHY_DIAG_ERRS_H_

#include <stdio.h>
#include <stdlib.h>
#include <infiniband/ibdiag/ibdiag_fabric_errs.h>
#include <infiniband/ibdiag/ibdiagnet/ibdiagnet_plugins_ifc.h>

#define FER_PHY_ERR_GENERAL      "PHY_ERR_GENERAL"

typedef enum {
    EN_GOOD                  = 0x0,
    EN_DEVICE_BUSY           = 0x1,
    EN_VERSION_NOT_SUPPORTED = 0x2,
    EN_UNKNOWN_TLV           = 0x3,
    EN_REG_UNSUPPORT         = 0x4,
    EN_CLASS_UNSUPPORT       = 0x5,
    EN_METHOD_UNSUPPORT      = 0x6,
    EN_BAD_PARAM             = 0x7,
    EN_RESOURCE_UNAVAILABLE  = 0x8,
    EN_MSG_RECEIPT_ACK       = 0x9
} EnOpTlvStatus_t;

class FabricPortErrPhyRetrieveGeneral : public FabricErrPort {
public:
    FabricPortErrPhyRetrieveGeneral(IBPort *p_port, u_int8_t status);
    ~FabricPortErrPhyRetrieveGeneral() {}
};

class FabricNodeErrPhyRetrieveGeneral : public FabricErrNode {
public:
    FabricNodeErrPhyRetrieveGeneral(IBNode *p_node, u_int8_t status);
    ~FabricNodeErrPhyRetrieveGeneral() {}
};

#endif //_PHY_DIAG_ERRS_H_
