
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         ibnl_parse
#define yylex           ibnl_lex
#define yyerror         ibnl_error
#define yylval          ibnl_lval
#define yychar          ibnl_char
#define yydebug         ibnl_debug
#define yynerrs         ibnl_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 32 "./ibnl_parser_bison.yy"

    /*
     * header section
     */
    #pragma warning(disable:4242)
    #include <stdio.h>
    #include <stdlib.h>
    #include <string.h>
    
    #include <infiniband/ibdm/SysDef.h>
    #include <infiniband/ibdm/Fabric.h>
    
    #ifndef alloca
        #define alloca malloc
    #endif

    #define YYERROR_VERBOSE
    #define YYTYPE_INT16 int

    extern int yyerror(const char *msg);
    extern int ibnl_lex(void);
    extern int ibnl_lex_destroy(void);


/* Line 189 of yacc.c  */
#line 106 "./generated_code/ibnl_parser.cc"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     INT_NUM = 258,
     SYSTEM = 259,
     TOPSYSTEM = 260,
     NODE = 261,
     SUBSYSTEM = 262,
     NODETYPE = 263,
     NAME = 264,
     SPEED = 265,
     WIDTH = 266,
     LINE = 267,
     CFG = 268,
     DASH = 269,
     END_DASH = 270
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 56 "./ibnl_parser_bison.yy"

    IBNodeType tval;
    int        ival;
    char      *sval;



/* Line 214 of yacc.c  */
#line 165 "./generated_code/ibnl_parser.cc"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */

/* Line 264 of yacc.c  */
#line 71 "./ibnl_parser_bison.yy"

static int ibnlErr;
long lineNum;
static const char *gp_fileName;
static int gIsTopSystem = 0;
static list< char * > gSysNames;
static IBSystemsCollection *gp_sysColl = 0;
static IBSysDef *gp_curSysDef = 0;
static IBSysInst *gp_curInstDef = 0;

void
ibnlMakeSystem(list< char * > &sysNames)
{
#ifdef DEBUG
    printf("Making new system named:");
#endif
    gp_curSysDef = new IBSysDef(gp_fileName);

    for( list< char * >::iterator snI = sysNames.begin();
            snI != sysNames.end(); snI++) {
        char sname[1024];
        if (gIsTopSystem) {
            sprintf(sname, "%s", *snI);
        } else {
            sprintf(sname, "%s/%s", gp_fileName, *snI);
        }
        string sNameStr(sname);
        gp_sysColl->addSysDef(sNameStr, gp_curSysDef);
#ifdef DEBUG
        printf("%s ", sname);
#endif
    }
#ifdef DEBUG
    printf("\n");
#endif

    // cleanup for next systems.
    sysNames.erase(sysNames.begin(), sysNames.end());
}

void
ibnlMakeSubInstAttribute(char *hInst, char *attr, char *value)
{
#ifdef DEBUG
    printf("Making new sub instance attribute inst:%s %s=%s\n",
            hInst, attr, value);
#endif
    if (!gp_curSysDef) {
        printf("-E- How com e we got no system???\n");
        exit(3);
    }
    // append to existing attr or create new
    string hierInstName = string(hInst);
    string attrStr = string(attr);
    if (value)
        attrStr += "=" +  string(value);
    gp_curSysDef->setSubInstAttr(hierInstName, attrStr);
}

void
ibnlMakeNode(IBNodeType type, phys_port_t numPorts, char *devName, char* name, int numVirtualPorts)
{
#ifdef DEBUG
    printf(" Making Node:%s dev:%s ports:%d\n", name, devName, (int)numPorts);
#endif
    gp_curInstDef = new IBSysInst(name, devName, numPorts, type, numVirtualPorts);
    gp_curSysDef->addInst(gp_curInstDef);
}

void
ibnlMakeNodeToNodeConn(int fromPort,
									const char *width, const char *speed,
									const char *toNode, int toPort)
{
#ifdef DEBUG
    printf("  Connecting N-N port:%d to Node:%s/%d (w=%s,s=%s)\n",
            fromPort, toNode, toPort, width, speed);
#endif
    char buf1[8],buf2[8] ;
    sprintf(buf1, "%d", toPort);
    sprintf(buf2, "%d", fromPort);
    IBSysInstPort *p_port =
            new IBSysInstPort(buf2, toNode, buf1,
                    char2width(width), char2speed(speed));
        gp_curInstDef->addPort(p_port);
}

void
ibnlMakeNodeToPortConn(int fromPort, const char *width, const char *speed,
        const char *sysPortName)
{
#ifdef DEBUG
    printf("  System port:%s on port:%d (w=%s,s=%s)\n",
            sysPortName, fromPort, width, speed);
#endif
    char buf[8];
    sprintf(buf,"%d",fromPort);
    IBSysPortDef *p_sysPort =
            new IBSysPortDef(sysPortName, gp_curInstDef->getName(), buf,
                    char2width(width), char2speed(speed));
    gp_curSysDef->addSysPort(p_sysPort);
}

void
ibnlMakeSubsystem(char *masterName, char *instName)
{
#ifdef DEBUG
    printf(" Making SubSystem:%s of type:%s\n", instName, masterName);
#endif
    gp_curInstDef = new IBSysInst(instName, masterName);
    gp_curSysDef->addInst(gp_curInstDef);
}

void
ibnlRecordModification(char *subSystem, char *modifier)
{
#ifdef DEBUG
    printf("  Using modifier:%s on %s\n", modifier, subSystem);
#endif
    gp_curInstDef->addInstMod(subSystem, modifier);
}

void
ibnlMakeSubsystemToSubsystemConn(char *fromPort, const char *width, const char *speed,
        char *toSystem, char *toPort)
{
#ifdef DEBUG
    printf("  Connecting S-S port:%s to SubSys:%s/%s\n",
            fromPort, toSystem, toPort);
#endif
    IBSysInstPort *p_port =
            new IBSysInstPort(fromPort, toSystem, toPort,
                    char2width(width), char2speed(speed));
    gp_curInstDef->addPort(p_port);
}

void
ibnlMakeSubsystemToPortConn(const char *fromPort, const char *width, const char *speed,
        const char *toPort)
{
#ifdef DEBUG
    printf("  Connecting port:%s to SysPort:%s\n",
            fromPort, toPort);
#endif
    IBSysPortDef *p_sysPort =
            new IBSysPortDef(toPort, gp_curInstDef->getName(), fromPort,
                    char2width(width), char2speed(speed));
    gp_curSysDef->addSysPort(p_sysPort);
}



/* Line 264 of yacc.c  */
#line 330 "./generated_code/ibnl_parser.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  7
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   87

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  19
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  30
/* YYNRULES -- Number of rules.  */
#define YYNRULES  58
/* YYNRULES -- Number of states.  */
#define YYNSTATES  111

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   270

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    18,    17,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    16,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     5,     8,     9,    11,    15,    16,    19,
      20,    24,    30,    36,    40,    41,    42,    50,    51,    52,
      59,    61,    65,    67,    68,    71,    74,    78,    84,    92,
      93,    97,    99,   101,   111,   119,   127,   133,   142,   149,
     156,   161,   165,   172,   176,   177,   180,   184,   185,   189,
     191,   193,   203,   211,   219,   225,   234,   241,   248
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      22,     0,    -1,    12,    -1,    20,    12,    -1,    -1,    20,
      -1,    21,    23,    26,    -1,    -1,    23,    29,    -1,    -1,
      24,    25,    20,    -1,     9,    16,     9,    16,     9,    -1,
       9,    16,     9,    16,     3,    -1,     9,    16,     9,    -1,
      -1,    -1,     5,    27,    32,    28,    20,    24,    34,    -1,
      -1,    -1,     4,    30,    32,    31,    20,    34,    -1,    33,
      -1,    32,    17,    33,    -1,     9,    -1,    -1,    34,    35,
      -1,    34,    41,    -1,    36,    20,    37,    -1,     6,     8,
       3,     9,     9,    -1,     6,     8,     3,    18,     3,     9,
       9,    -1,    -1,    37,    38,    20,    -1,    39,    -1,    40,
      -1,     3,    14,    11,    14,    10,    14,    15,     9,     3,
      -1,     3,    14,    11,    14,    15,     9,     3,    -1,     3,
      14,    10,    14,    15,     9,     3,    -1,     3,    14,    15,
       9,     3,    -1,     3,    14,    11,    14,    10,    14,    15,
       9,    -1,     3,    14,    11,    14,    15,     9,    -1,     3,
      14,    10,    14,    15,     9,    -1,     3,    14,    15,     9,
      -1,    42,    20,    45,    -1,    42,    20,    13,    43,    20,
      45,    -1,     7,     9,     9,    -1,    -1,    43,    44,    -1,
       9,    16,     9,    -1,    -1,    45,    46,    20,    -1,    47,
      -1,    48,    -1,     9,    14,    11,    14,    10,    14,    15,
       9,     9,    -1,     9,    14,    11,    14,    15,     9,     9,
      -1,     9,    14,    10,    14,    15,     9,     9,    -1,     9,
      14,    15,     9,     9,    -1,     9,    14,    11,    14,    10,
      14,    15,     9,    -1,     9,    14,    11,    14,    15,     9,
      -1,     9,    14,    10,    14,    15,     9,    -1,     9,    14,
      15,     9,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   226,   226,   227,   229,   230,   232,   234,   235,   238,
     239,   243,   244,   249,   253,   254,   253,   260,   261,   260,
     265,   266,   270,   273,   274,   275,   279,   283,   284,   287,
     288,   292,   293,   297,   300,   303,   306,   312,   315,   318,
     321,   327,   328,   332,   335,   336,   340,   343,   344,   348,
     349,   353,   356,   359,   362,   368,   371,   374,   377
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "INT_NUM", "SYSTEM", "TOPSYSTEM", "NODE",
  "SUBSYSTEM", "NODETYPE", "NAME", "SPEED", "WIDTH", "LINE", "CFG", "DASH",
  "END_DASH", "'='", "','", "'+'", "$accept", "NL", "ONL", "ibnl",
  "systems", "sub_inst_attributes", "sub_inst_attribute", "topsystem",
  "$@1", "$@2", "system", "$@3", "$@4", "system_names", "system_name",
  "insts", "node", "node_header", "node_connections", "node_connection",
  "node_to_node_link", "node_to_port_link", "subsystem",
  "subsystem_header", "insts_modifications", "modification",
  "subsystem_connections", "subsystem_connection",
  "subsystem_to_subsystem_link", "subsystem_to_port_link", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    61,    44,    43
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    19,    20,    20,    21,    21,    22,    23,    23,    24,
      24,    25,    25,    25,    27,    28,    26,    30,    31,    29,
      32,    32,    33,    34,    34,    34,    35,    36,    36,    37,
      37,    38,    38,    39,    39,    39,    39,    40,    40,    40,
      40,    41,    41,    42,    43,    43,    44,    45,    45,    46,
      46,    47,    47,    47,    47,    48,    48,    48,    48
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     0,     1,     3,     0,     2,     0,
       3,     5,     5,     3,     0,     0,     7,     0,     0,     6,
       1,     3,     1,     0,     2,     2,     3,     5,     7,     0,
       3,     1,     1,     9,     7,     7,     5,     8,     6,     6,
       4,     3,     6,     3,     0,     2,     3,     0,     3,     1,
       1,     9,     7,     7,     5,     8,     6,     6,     4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       4,     2,     5,     7,     0,     3,     0,     1,    17,    14,
       6,     8,     0,     0,    22,    18,    20,    15,     0,     0,
       0,    21,    23,     9,    19,    23,     0,     0,    24,     0,
      25,     0,     0,     0,    16,     0,     0,    29,    47,     0,
      10,     0,    43,    26,    44,    41,    13,     0,     0,     0,
       0,    31,    32,     0,     0,     0,    49,    50,     0,    27,
       0,     0,    30,     0,    47,    45,     0,    48,    12,    11,
       0,     0,     0,     0,     0,    42,     0,     0,     0,    28,
       0,     0,    40,    46,     0,     0,    58,     0,     0,     0,
      36,     0,     0,     0,    54,    39,     0,    38,    57,     0,
      56,    35,     0,    34,    53,     0,    52,    37,    55,    33,
      51
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     2,     3,     4,     6,    25,    33,    10,    13,    20,
      11,    12,    19,    15,    16,    24,    28,    29,    43,    50,
      51,    52,    30,    31,    53,    65,    45,    55,    56,    57
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -20
static const yytype_int8 yypact[] =
{
      11,   -20,    17,   -20,    21,   -20,     1,   -20,   -20,   -20,
     -20,   -20,    23,    23,   -20,    13,   -20,    13,    23,    11,
      11,   -20,    17,    17,    19,    24,    27,    28,   -20,    11,
     -20,    11,    22,    11,    19,    36,    31,    17,    15,    32,
      17,    -7,   -20,    39,   -20,    34,    29,    35,    43,    33,
      11,   -20,   -20,    -5,    37,    11,   -20,   -20,     0,   -20,
      40,     5,    17,    38,    17,   -20,     7,    17,   -20,   -20,
      41,    42,    44,    46,    48,    34,    45,    47,    51,   -20,
      49,    -2,    50,   -20,    52,     9,    53,    54,    55,    56,
     -20,    57,    58,    59,   -20,    67,    60,    68,    64,    61,
      65,   -20,    69,   -20,   -20,    70,   -20,    74,    71,   -20,
     -20
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -20,   -19,   -20,   -20,   -20,   -20,   -20,   -20,   -20,   -20,
     -20,   -20,   -20,    72,    30,    62,   -20,   -20,   -20,   -20,
     -20,   -20,   -20,   -20,   -20,   -20,   -12,   -20,   -20,   -20
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      22,    23,    47,    68,    63,     8,     9,     1,    88,    69,
      37,    48,    38,    89,    40,    71,    72,    76,    77,    92,
      73,     7,    78,     1,    93,    26,    27,     5,    44,     5,
      18,    62,    14,    32,    64,    35,    67,    36,    39,    41,
      42,    46,    49,    54,    59,    58,    60,    61,    21,    70,
      79,    66,    75,    90,    74,    82,    80,    83,    81,    84,
      86,    85,    94,    95,    87,    97,    98,    91,   100,    96,
     101,   103,    99,   104,   106,   102,   105,   109,   107,   108,
     110,     0,     0,     0,     0,    17,     0,    34
};

static const yytype_int8 yycheck[] =
{
      19,    20,     9,     3,     9,     4,     5,    12,    10,     9,
      29,    18,    31,    15,    33,    10,    11,    10,    11,    10,
      15,     0,    15,    12,    15,     6,     7,    12,    13,    12,
      17,    50,     9,     9,    53,     8,    55,     9,    16,     3,
       9,     9,     3,     9,     9,    16,     3,    14,    18,     9,
       9,    14,    64,     3,    16,     9,    14,     9,    14,    14,
       9,    14,     9,     9,    15,     9,     9,    15,     9,    14,
       3,     3,    14,     9,     9,    15,    15,     3,     9,     9,
       9,    -1,    -1,    -1,    -1,    13,    -1,    25
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    12,    20,    21,    22,    12,    23,     0,     4,     5,
      26,    29,    30,    27,     9,    32,    33,    32,    17,    31,
      28,    33,    20,    20,    34,    24,     6,     7,    35,    36,
      41,    42,     9,    25,    34,     8,     9,    20,    20,    16,
      20,     3,     9,    37,    13,    45,     9,     9,    18,     3,
      38,    39,    40,    43,     9,    46,    47,    48,    16,     9,
       3,    14,    20,     9,    20,    44,    14,    20,     3,     9,
       9,    10,    11,    15,    16,    45,    10,    11,    15,     9,
      14,    14,     9,     9,    14,    14,     9,    15,    10,    15,
       3,    15,    10,    15,     9,     9,    14,     9,     9,    14,
       9,     3,    15,     3,     9,    15,     9,     9,     9,     3,
       9
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 11:

/* Line 1455 of yacc.c  */
#line 243 "./ibnl_parser_bison.yy"
    { ibnlMakeSubInstAttribute((yyvsp[(1) - (5)].sval),(yyvsp[(3) - (5)].sval),(yyvsp[(5) - (5)].sval)); ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 244 "./ibnl_parser_bison.yy"
    {
        char buf[16];
        sprintf(buf, "%d", (yyvsp[(5) - (5)].ival));
        ibnlMakeSubInstAttribute((yyvsp[(1) - (5)].sval),(yyvsp[(3) - (5)].sval),buf);
    ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 249 "./ibnl_parser_bison.yy"
    {ibnlMakeSubInstAttribute((yyvsp[(1) - (3)].sval),(yyvsp[(3) - (3)].sval),NULL); ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 253 "./ibnl_parser_bison.yy"
    { gIsTopSystem = 1; ;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 254 "./ibnl_parser_bison.yy"
    { ibnlMakeSystem(gSysNames); ;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 260 "./ibnl_parser_bison.yy"
    { gIsTopSystem = 0; ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 261 "./ibnl_parser_bison.yy"
    { ibnlMakeSystem(gSysNames); ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 270 "./ibnl_parser_bison.yy"
    { gSysNames.push_back((yyvsp[(1) - (1)].sval)); ;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 283 "./ibnl_parser_bison.yy"
    { ibnlMakeNode((yyvsp[(2) - (5)].tval),(phys_port_t)(yyvsp[(3) - (5)].ival)   ,(yyvsp[(4) - (5)].sval),(yyvsp[(5) - (5)].sval), 0); ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 284 "./ibnl_parser_bison.yy"
    { ibnlMakeNode((yyvsp[(2) - (7)].tval),(phys_port_t)(yyvsp[(3) - (7)].ival)+(yyvsp[(5) - (7)].ival),(yyvsp[(6) - (7)].sval),(yyvsp[(7) - (7)].sval), (yyvsp[(5) - (7)].ival)); ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 297 "./ibnl_parser_bison.yy"
    {
        ibnlMakeNodeToNodeConn((yyvsp[(1) - (9)].ival), (yyvsp[(3) - (9)].sval), (yyvsp[(5) - (9)].sval), (yyvsp[(8) - (9)].sval), (yyvsp[(9) - (9)].ival));
    ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 300 "./ibnl_parser_bison.yy"
    {
        ibnlMakeNodeToNodeConn((yyvsp[(1) - (7)].ival), (yyvsp[(3) - (7)].sval), "2.5", (yyvsp[(6) - (7)].sval), (yyvsp[(7) - (7)].ival));
    ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 303 "./ibnl_parser_bison.yy"
    {
        ibnlMakeNodeToNodeConn((yyvsp[(1) - (7)].ival), "4x", (yyvsp[(3) - (7)].sval), (yyvsp[(6) - (7)].sval), (yyvsp[(7) - (7)].ival));
    ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 306 "./ibnl_parser_bison.yy"
    {
        ibnlMakeNodeToNodeConn((yyvsp[(1) - (5)].ival), "4x", "2.5", (yyvsp[(4) - (5)].sval), (yyvsp[(5) - (5)].ival));
    ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 312 "./ibnl_parser_bison.yy"
    {
        ibnlMakeNodeToPortConn((yyvsp[(1) - (8)].ival), (yyvsp[(3) - (8)].sval), (yyvsp[(5) - (8)].sval), (yyvsp[(8) - (8)].sval));
    ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 315 "./ibnl_parser_bison.yy"
    {
        ibnlMakeNodeToPortConn((yyvsp[(1) - (6)].ival), (yyvsp[(3) - (6)].sval), "2.5", (yyvsp[(6) - (6)].sval));
    ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 318 "./ibnl_parser_bison.yy"
    {
        ibnlMakeNodeToPortConn((yyvsp[(1) - (6)].ival), "4x", (yyvsp[(3) - (6)].sval), (yyvsp[(6) - (6)].sval));
    ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 321 "./ibnl_parser_bison.yy"
    {
        ibnlMakeNodeToPortConn((yyvsp[(1) - (4)].ival), "4x", "2.5", (yyvsp[(4) - (4)].sval));
    ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 332 "./ibnl_parser_bison.yy"
    { ibnlMakeSubsystem((yyvsp[(2) - (3)].sval),(yyvsp[(3) - (3)].sval)); ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 340 "./ibnl_parser_bison.yy"
    { ibnlRecordModification((yyvsp[(1) - (3)].sval),(yyvsp[(3) - (3)].sval)); ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 353 "./ibnl_parser_bison.yy"
    {
        ibnlMakeSubsystemToSubsystemConn((yyvsp[(1) - (9)].sval), (yyvsp[(3) - (9)].sval), (yyvsp[(5) - (9)].sval), (yyvsp[(8) - (9)].sval), (yyvsp[(9) - (9)].sval));
    ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 356 "./ibnl_parser_bison.yy"
    {
        ibnlMakeSubsystemToSubsystemConn((yyvsp[(1) - (7)].sval), (yyvsp[(3) - (7)].sval), "2.5", (yyvsp[(6) - (7)].sval), (yyvsp[(7) - (7)].sval));
    ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 359 "./ibnl_parser_bison.yy"
    {
        ibnlMakeSubsystemToSubsystemConn((yyvsp[(1) - (7)].sval), "4x", (yyvsp[(3) - (7)].sval), (yyvsp[(6) - (7)].sval), (yyvsp[(7) - (7)].sval));
    ;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 362 "./ibnl_parser_bison.yy"
    {
        ibnlMakeSubsystemToSubsystemConn((yyvsp[(1) - (5)].sval), "4x", "2.5", (yyvsp[(4) - (5)].sval), (yyvsp[(5) - (5)].sval));
    ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 368 "./ibnl_parser_bison.yy"
    {
        ibnlMakeSubsystemToPortConn((yyvsp[(1) - (8)].sval), (yyvsp[(3) - (8)].sval), (yyvsp[(5) - (8)].sval), (yyvsp[(8) - (8)].sval));
    ;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 371 "./ibnl_parser_bison.yy"
    {
        ibnlMakeSubsystemToPortConn((yyvsp[(1) - (6)].sval), (yyvsp[(3) - (6)].sval), "2.5", (yyvsp[(6) - (6)].sval));
    ;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 374 "./ibnl_parser_bison.yy"
    {
        ibnlMakeSubsystemToPortConn((yyvsp[(1) - (6)].sval), "4x", (yyvsp[(3) - (6)].sval), (yyvsp[(6) - (6)].sval));
    ;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 377 "./ibnl_parser_bison.yy"
    {
        ibnlMakeSubsystemToPortConn((yyvsp[(1) - (4)].sval), "4x", "2.5", (yyvsp[(4) - (4)].sval));
    ;}
    break;



/* Line 1455 of yacc.c  */
#line 1848 "./generated_code/ibnl_parser.cc"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 383 "./ibnl_parser_bison.yy"

int yyerror(const char *msg)
{
    printf("-E-ibnlParse:%s at line:%ld\n", msg, lineNum);
    ibnlErr = 1;
    return 1;
}


/*
 * parse apollo route dump fil
 */
int ibnlParseSysDefs (IBSystemsCollection *p_sysColl, const char *fileName)
{
    extern FILE * ibnl_in;

    gp_sysColl = p_sysColl;
    gp_fileName = fileName;

    /*
     * open the file
     */
    ibnl_in = fopen(fileName,"r");
    if (!ibnl_in) {
        printf("-E- Fail to Open File:%s\n", fileName);
        return(1);
    }
    if (FabricUtilsVerboseLevel & FABU_LOG_VERBOSE)
        printf("-I- Parsing:%s\n", fileName);

    ibnlErr = 0;
    lineNum = 1;

    /*
     * parse it
     */
    yyparse();

    fclose(ibnl_in);
    ibnl_lex_destroy();
    return(ibnlErr);
}

