/*                  - Mellanox Confidential and Proprietary -
 *
 *  Copyright (C) 2010-2019, Mellanox Technologies Ltd.  ALL RIGHTS RESERVED.
 *
 *  Except as specifically permitted herein, no portion of the information,
 *  including but not limited to object code and source code, may be reproduced,
 *  modified, distributed, republished or otherwise exploited in any form or by
 *  any means for any purpose without the prior written permission of Mellanox
 *  Technologies Ltd. Use of software subject to the terms and conditions
 *  detailed in the file "LICENSE.txt".
 *
 */



/***
         *** This file was generated at "2019-09-12 16:26:38"
         *** by:
         ***    > /mswg/release/tools/a-me/a-me-1.0.99/adabe_plugins/adb2c/adb2pack.py --input adb/internal_packets.adb --file-prefix internal_packets --copyright=/opt/copyrights
         ***/
#include "internal_packets_layouts.h"

void int64bit_pack(const struct int64bit *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->High);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Low);

}

void int64bit_unpack(struct int64bit *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->High = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->Low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void int64bit_print(const struct int64bit *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== int64bit ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "High                 : " U32H_FMT "\n", ptr_struct->High);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Low                  : " U32H_FMT "\n", ptr_struct->Low);

}

int int64bit_size(void)
{
	return 8;
}

void int64bit_dump(const struct int64bit *ptr_struct, FILE *file)
{
	int64bit_print(ptr_struct, file, 0);
}

void pll_status_16nm_pack(const struct pll_status_16nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->pll_speed);

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->clock_valid);

	offset = 27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->plllock_clk_val);

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lock_clk_val_cause);

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->clear_cause);

	offset = 23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ae);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lock_lost_counter);

	offset = 3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lock_pulse);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pll_pwrup);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lock_status);

	offset = 54;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fctrl_measure);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->mid_val);

	offset = 43;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->low_var);

	offset = 38;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->high_var);

	offset = 33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->analog_var);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lock);

}

void pll_status_16nm_unpack(struct pll_status_16nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	ptr_struct->pll_speed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 28;
	ptr_struct->clock_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 27;
	ptr_struct->plllock_clk_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 25;
	ptr_struct->lock_clk_val_cause = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 24;
	ptr_struct->clear_cause = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 23;
	ptr_struct->ae = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 7;
	ptr_struct->lock_lost_counter = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 3;
	ptr_struct->lock_pulse = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 2;
	ptr_struct->pll_pwrup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->lock_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 54;
	ptr_struct->fctrl_measure = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 48;
	ptr_struct->mid_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 43;
	ptr_struct->low_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 38;
	ptr_struct->high_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 33;
	ptr_struct->analog_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 32;
	ptr_struct->lock = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void pll_status_16nm_print(const struct pll_status_16nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pll_status_16nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_speed            : " UH_FMT "\n", ptr_struct->pll_speed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clock_valid          : " UH_FMT "\n", ptr_struct->clock_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plllock_clk_val      : " UH_FMT "\n", ptr_struct->plllock_clk_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock_clk_val_cause   : " UH_FMT "\n", ptr_struct->lock_clk_val_cause);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clear_cause          : " UH_FMT "\n", ptr_struct->clear_cause);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ae                   : " UH_FMT "\n", ptr_struct->ae);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock_lost_counter    : " UH_FMT "\n", ptr_struct->lock_lost_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock_pulse           : " UH_FMT "\n", ptr_struct->lock_pulse);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_pwrup            : " UH_FMT "\n", ptr_struct->pll_pwrup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock_status          : " UH_FMT "\n", ptr_struct->lock_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fctrl_measure        : " UH_FMT "\n", ptr_struct->fctrl_measure);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mid_val              : " UH_FMT "\n", ptr_struct->mid_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "low_var              : " UH_FMT "\n", ptr_struct->low_var);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "high_var             : " UH_FMT "\n", ptr_struct->high_var);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "analog_var           : " UH_FMT "\n", ptr_struct->analog_var);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock                 : " UH_FMT "\n", ptr_struct->lock);

}

int pll_status_16nm_size(void)
{
	return 8;
}

void pll_status_16nm_dump(const struct pll_status_16nm *ptr_struct, FILE *file)
{
	pll_status_16nm_print(ptr_struct, file, 0);
}

void pll_status_28nm_pack(const struct pll_status_28nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->f_ctrl_measure);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->analog_algo_num_var);

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->algo_f_ctrl);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lock_status);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lock_cal);

	offset = 58;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->mid_var);

	offset = 50;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->low_var);

	offset = 42;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->high_var);

	offset = 34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->analog_var);

}

void pll_status_28nm_unpack(struct pll_status_28nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 22;
	ptr_struct->f_ctrl_measure = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 16;
	ptr_struct->analog_algo_num_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 6;
	ptr_struct->algo_f_ctrl = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 2;
	ptr_struct->lock_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 1;
	ptr_struct->lock_cal = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 58;
	ptr_struct->mid_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 50;
	ptr_struct->low_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 42;
	ptr_struct->high_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 34;
	ptr_struct->analog_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

}

void pll_status_28nm_print(const struct pll_status_28nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pll_status_28nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "f_ctrl_measure       : " UH_FMT "\n", ptr_struct->f_ctrl_measure);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "analog_algo_num_var  : " UH_FMT "\n", ptr_struct->analog_algo_num_var);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "algo_f_ctrl          : " UH_FMT "\n", ptr_struct->algo_f_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock_status          : " UH_FMT "\n", ptr_struct->lock_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock_cal             : " UH_FMT "\n", ptr_struct->lock_cal);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mid_var              : " UH_FMT "\n", ptr_struct->mid_var);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "low_var              : " UH_FMT "\n", ptr_struct->low_var);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "high_var             : " UH_FMT "\n", ptr_struct->high_var);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "analog_var           : " UH_FMT "\n", ptr_struct->analog_var);

}

int pll_status_28nm_size(void)
{
	return 8;
}

void pll_status_28nm_dump(const struct pll_status_28nm *ptr_struct, FILE *file)
{
	pll_status_28nm_print(ptr_struct, file, 0);
}

void pll_status_data_pack(const struct pll_status_data *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 64, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void pll_status_data_unpack(struct pll_status_data *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 64, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void pll_status_data_print(const struct pll_status_data *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pll_status_data ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int pll_status_data_size(void)
{
	return 8;
}

void pll_status_data_dump(const struct pll_status_data *ptr_struct, FILE *file)
{
	pll_status_data_print(ptr_struct, file, 0);
}

void slrg_16nm_pack(const struct slrg_16nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->grade_lane_speed);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->grade_version);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->grade);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->up_eye_grade);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mid_eye_grade);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dn_eye_grade);

}

void slrg_16nm_unpack(struct slrg_16nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->grade_lane_speed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->grade_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->grade = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->up_eye_grade = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->mid_eye_grade = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->dn_eye_grade = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void slrg_16nm_print(const struct slrg_16nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrg_16nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade_lane_speed     : " UH_FMT "\n", ptr_struct->grade_lane_speed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade_version        : " UH_FMT "\n", ptr_struct->grade_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade                : " UH_FMT "\n", ptr_struct->grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "up_eye_grade         : " UH_FMT "\n", ptr_struct->up_eye_grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mid_eye_grade        : " UH_FMT "\n", ptr_struct->mid_eye_grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dn_eye_grade         : " UH_FMT "\n", ptr_struct->dn_eye_grade);

}

int slrg_16nm_size(void)
{
	return 36;
}

void slrg_16nm_dump(const struct slrg_16nm *ptr_struct, FILE *file)
{
	slrg_16nm_print(ptr_struct, file, 0);
}

void slrg_28nm_pack(const struct slrg_28nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->grade_lane_speed);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->grade);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->grade_version);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->height_grade);

	offset = 68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->height_grade_type);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->height_dv);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->height_dz);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->height_sigma);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->phase_grade);

	offset = 164;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->phase_grade_type);

	offset = 248;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phase_eo_neg);

	offset = 232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phase_eo_pos);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->test_errors_per_lane);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ffe_set_tested);

}

void slrg_28nm_unpack(struct slrg_28nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->grade_lane_speed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 40;
	ptr_struct->grade = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 32;
	ptr_struct->grade_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->height_grade = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 68;
	ptr_struct->height_grade_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 112;
	ptr_struct->height_dv = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->height_dz = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->height_sigma = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 168;
	ptr_struct->phase_grade = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 164;
	ptr_struct->phase_grade_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 248;
	ptr_struct->phase_eo_neg = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 232;
	ptr_struct->phase_eo_pos = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 272;
	ptr_struct->test_errors_per_lane = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 256;
	ptr_struct->ffe_set_tested = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void slrg_28nm_print(const struct slrg_28nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrg_28nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade_lane_speed     : " UH_FMT "\n", ptr_struct->grade_lane_speed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade                : " UH_FMT "\n", ptr_struct->grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade_version        : " UH_FMT "\n", ptr_struct->grade_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_grade         : " UH_FMT "\n", ptr_struct->height_grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_grade_type    : " UH_FMT "\n", ptr_struct->height_grade_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_dv            : " UH_FMT "\n", ptr_struct->height_dv);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_dz            : " UH_FMT "\n", ptr_struct->height_dz);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_sigma         : " UH_FMT "\n", ptr_struct->height_sigma);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_grade          : " UH_FMT "\n", ptr_struct->phase_grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_grade_type     : " UH_FMT "\n", ptr_struct->phase_grade_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_eo_neg         : " UH_FMT "\n", ptr_struct->phase_eo_neg);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_eo_pos         : " UH_FMT "\n", ptr_struct->phase_eo_pos);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "test_errors_per_lane : " UH_FMT "\n", ptr_struct->test_errors_per_lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_set_tested       : " UH_FMT "\n", ptr_struct->ffe_set_tested);

}

int slrg_28nm_size(void)
{
	return 36;
}

void slrg_28nm_dump(const struct slrg_28nm *ptr_struct, FILE *file)
{
	slrg_28nm_print(ptr_struct, file, 0);
}

void slrg_data_set_pack(const struct slrg_data_set *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 36; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 288, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void slrg_data_set_unpack(struct slrg_data_set *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 36; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 288, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void slrg_data_set_print(const struct slrg_data_set *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrg_data_set ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 36; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int slrg_data_set_size(void)
{
	return 36;
}

void slrg_data_set_dump(const struct slrg_data_set *ptr_struct, FILE *file)
{
	slrg_data_set_print(ptr_struct, file, 0);
}

void slrp_16nm_pack(const struct slrp_16nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->dp_sel);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_ref_out_mixer_biasgen_eo);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_ref_out_mixer_biasgen_down);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_ref_out_mixer_biasgen_mid);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_ref_out_mixer_biasgen_up);

	offset = 44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_ref_in_mixer_biasgen_eo);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_ref_in_mixer_biasgen_down);

	offset = 36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_ref_in_mixer_biasgen_mid);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_ref_in_mixer_biasgen_up);

	offset = 92;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->gctrl_bin_bgn1_p);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->gctrl_bin_bgn1_n);

	offset = 84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->gctrl_bin_bgn0_p);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->gctrl_bin_bgn0_n);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixer_offset_eye_scan);

	offset = 70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sel_amp_mixer_biasgen_eo);

	offset = 68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sel_amp_mixer_biasgen_down);

	offset = 66;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sel_amp_mixer_biasgen_mid);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sel_amp_mixer_biasgen_up);

	offset = 122;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_bias_en_2);

	offset = 118;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_bias_en_1);

	offset = 114;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_bias_en_0);

	offset = 109;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->selgc_ref_op1_alev_ctle);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->selgc_ref_op0_alev_ctle);

	offset = 98;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->sel_bias2ctle);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sel_digital_gctrl);

	offset = 153;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrln_en_2);

	offset = 149;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrln_en_1);

	offset = 145;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrln_en_0);

	offset = 140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->sel_bias_en_6);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_bias_en_5);

	offset = 132;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_bias_en_4);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_bias_en_3);

	offset = 188;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrlp_en_3);

	offset = 184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrlp_en_2);

	offset = 180;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrlp_en_1);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrlp_en_0);

	offset = 172;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrln_en_6);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrln_en_5);

	offset = 164;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrln_en_4);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrln_en_3);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrlp_en_6);

	offset = 196;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrlp_en_5);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrlp_en_4);

}

void slrp_16nm_unpack(struct slrp_16nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	ptr_struct->dp_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 60;
	ptr_struct->sel_ref_out_mixer_biasgen_eo = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 56;
	ptr_struct->sel_ref_out_mixer_biasgen_down = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 52;
	ptr_struct->sel_ref_out_mixer_biasgen_mid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->sel_ref_out_mixer_biasgen_up = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 44;
	ptr_struct->sel_ref_in_mixer_biasgen_eo = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 40;
	ptr_struct->sel_ref_in_mixer_biasgen_down = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 36;
	ptr_struct->sel_ref_in_mixer_biasgen_mid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->sel_ref_in_mixer_biasgen_up = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 92;
	ptr_struct->gctrl_bin_bgn1_p = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 88;
	ptr_struct->gctrl_bin_bgn1_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 84;
	ptr_struct->gctrl_bin_bgn0_p = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 80;
	ptr_struct->gctrl_bin_bgn0_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 72;
	ptr_struct->mixer_offset_eye_scan = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 70;
	ptr_struct->sel_amp_mixer_biasgen_eo = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 68;
	ptr_struct->sel_amp_mixer_biasgen_down = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 66;
	ptr_struct->sel_amp_mixer_biasgen_mid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 64;
	ptr_struct->sel_amp_mixer_biasgen_up = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 122;
	ptr_struct->sel_bias_en_2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 118;
	ptr_struct->sel_bias_en_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 114;
	ptr_struct->sel_bias_en_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 109;
	ptr_struct->selgc_ref_op1_alev_ctle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 104;
	ptr_struct->selgc_ref_op0_alev_ctle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 98;
	ptr_struct->sel_bias2ctle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 96;
	ptr_struct->sel_digital_gctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 153;
	ptr_struct->sel_gctrln_en_2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 149;
	ptr_struct->sel_gctrln_en_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 145;
	ptr_struct->sel_gctrln_en_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 140;
	ptr_struct->sel_bias_en_6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 136;
	ptr_struct->sel_bias_en_5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 132;
	ptr_struct->sel_bias_en_4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->sel_bias_en_3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 188;
	ptr_struct->sel_gctrlp_en_3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 184;
	ptr_struct->sel_gctrlp_en_2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 180;
	ptr_struct->sel_gctrlp_en_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 176;
	ptr_struct->sel_gctrlp_en_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 172;
	ptr_struct->sel_gctrln_en_6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 168;
	ptr_struct->sel_gctrln_en_5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 164;
	ptr_struct->sel_gctrln_en_4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->sel_gctrln_en_3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 200;
	ptr_struct->sel_gctrlp_en_6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 196;
	ptr_struct->sel_gctrlp_en_5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->sel_gctrlp_en_4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void slrp_16nm_print(const struct slrp_16nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrp_16nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_sel               : " UH_FMT "\n", ptr_struct->dp_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_ref_out_mixer_biasgen_eo : " UH_FMT "\n", ptr_struct->sel_ref_out_mixer_biasgen_eo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_ref_out_mixer_biasgen_down : " UH_FMT "\n", ptr_struct->sel_ref_out_mixer_biasgen_down);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_ref_out_mixer_biasgen_mid : " UH_FMT "\n", ptr_struct->sel_ref_out_mixer_biasgen_mid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_ref_out_mixer_biasgen_up : " UH_FMT "\n", ptr_struct->sel_ref_out_mixer_biasgen_up);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_ref_in_mixer_biasgen_eo : " UH_FMT "\n", ptr_struct->sel_ref_in_mixer_biasgen_eo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_ref_in_mixer_biasgen_down : " UH_FMT "\n", ptr_struct->sel_ref_in_mixer_biasgen_down);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_ref_in_mixer_biasgen_mid : " UH_FMT "\n", ptr_struct->sel_ref_in_mixer_biasgen_mid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_ref_in_mixer_biasgen_up : " UH_FMT "\n", ptr_struct->sel_ref_in_mixer_biasgen_up);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gctrl_bin_bgn1_p     : " UH_FMT "\n", ptr_struct->gctrl_bin_bgn1_p);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gctrl_bin_bgn1_n     : " UH_FMT "\n", ptr_struct->gctrl_bin_bgn1_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gctrl_bin_bgn0_p     : " UH_FMT "\n", ptr_struct->gctrl_bin_bgn0_p);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gctrl_bin_bgn0_n     : " UH_FMT "\n", ptr_struct->gctrl_bin_bgn0_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset_eye_scan : " UH_FMT "\n", ptr_struct->mixer_offset_eye_scan);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_amp_mixer_biasgen_eo : " UH_FMT "\n", ptr_struct->sel_amp_mixer_biasgen_eo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_amp_mixer_biasgen_down : " UH_FMT "\n", ptr_struct->sel_amp_mixer_biasgen_down);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_amp_mixer_biasgen_mid : " UH_FMT "\n", ptr_struct->sel_amp_mixer_biasgen_mid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_amp_mixer_biasgen_up : " UH_FMT "\n", ptr_struct->sel_amp_mixer_biasgen_up);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_bias_en_2        : " UH_FMT "\n", ptr_struct->sel_bias_en_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_bias_en_1        : " UH_FMT "\n", ptr_struct->sel_bias_en_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_bias_en_0        : " UH_FMT "\n", ptr_struct->sel_bias_en_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "selgc_ref_op1_alev_ctle : " UH_FMT "\n", ptr_struct->selgc_ref_op1_alev_ctle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "selgc_ref_op0_alev_ctle : " UH_FMT "\n", ptr_struct->selgc_ref_op0_alev_ctle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_bias2ctle        : " UH_FMT "\n", ptr_struct->sel_bias2ctle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_digital_gctrl    : " UH_FMT "\n", ptr_struct->sel_digital_gctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrln_en_2      : " UH_FMT "\n", ptr_struct->sel_gctrln_en_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrln_en_1      : " UH_FMT "\n", ptr_struct->sel_gctrln_en_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrln_en_0      : " UH_FMT "\n", ptr_struct->sel_gctrln_en_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_bias_en_6        : " UH_FMT "\n", ptr_struct->sel_bias_en_6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_bias_en_5        : " UH_FMT "\n", ptr_struct->sel_bias_en_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_bias_en_4        : " UH_FMT "\n", ptr_struct->sel_bias_en_4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_bias_en_3        : " UH_FMT "\n", ptr_struct->sel_bias_en_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrlp_en_3      : " UH_FMT "\n", ptr_struct->sel_gctrlp_en_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrlp_en_2      : " UH_FMT "\n", ptr_struct->sel_gctrlp_en_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrlp_en_1      : " UH_FMT "\n", ptr_struct->sel_gctrlp_en_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrlp_en_0      : " UH_FMT "\n", ptr_struct->sel_gctrlp_en_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrln_en_6      : " UH_FMT "\n", ptr_struct->sel_gctrln_en_6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrln_en_5      : " UH_FMT "\n", ptr_struct->sel_gctrln_en_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrln_en_4      : " UH_FMT "\n", ptr_struct->sel_gctrln_en_4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrln_en_3      : " UH_FMT "\n", ptr_struct->sel_gctrln_en_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrlp_en_6      : " UH_FMT "\n", ptr_struct->sel_gctrlp_en_6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrlp_en_5      : " UH_FMT "\n", ptr_struct->sel_gctrlp_en_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrlp_en_4      : " UH_FMT "\n", ptr_struct->sel_gctrlp_en_4);

}

int slrp_16nm_size(void)
{
	return 36;
}

void slrp_16nm_dump(const struct slrp_16nm *ptr_struct, FILE *file)
{
	slrp_16nm_print(ptr_struct, file, 0);
}

void slrp_28nm_pack(const struct slrp_28nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mix90phase);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp90sel);

	offset = 19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dp_sel);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ib_sel);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap3);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap2);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap1);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap0);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap7);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap6);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap5);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap4);

	offset = 119;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->ffe_tap_en);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixerbias_tap_amp);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap8);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->slicer_offset0);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap_offset1);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap_offset0);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mixer_offset1);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mixer_offset0);

	offset = 216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixerbgn_refn);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixerbgn_refp);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixerbgn_inn);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixerbgn_inp);

	offset = 248;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixer_offset_cm1);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->lctrl_input);

	offset = 232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->slicer_gctrl);

	offset = 227;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->ref_mixer_vreg);

	offset = 225;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sel_slicer_lctrl_l);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sel_slicer_lctrl_h);

	offset = 279;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->slicer_offset_cm);

	offset = 263;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->mixer_offset_cm0);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->common_mode);

}

void slrp_28nm_unpack(struct slrp_28nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->mix90phase = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 20;
	ptr_struct->dp90sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 19;
	ptr_struct->dp_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->ib_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 56;
	ptr_struct->ffe_tap3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->ffe_tap2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->ffe_tap1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->ffe_tap0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->ffe_tap7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->ffe_tap6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->ffe_tap5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->ffe_tap4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 119;
	ptr_struct->ffe_tap_en = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset = 104;
	ptr_struct->mixerbias_tap_amp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->ffe_tap8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->slicer_offset0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 136;
	ptr_struct->ffe_tap_offset1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->ffe_tap_offset0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 176;
	ptr_struct->mixer_offset1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->mixer_offset0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 216;
	ptr_struct->mixerbgn_refn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 208;
	ptr_struct->mixerbgn_refp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 200;
	ptr_struct->mixerbgn_inn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->mixerbgn_inp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 248;
	ptr_struct->mixer_offset_cm1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 240;
	ptr_struct->lctrl_input = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 232;
	ptr_struct->slicer_gctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 227;
	ptr_struct->ref_mixer_vreg = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 225;
	ptr_struct->sel_slicer_lctrl_l = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 224;
	ptr_struct->sel_slicer_lctrl_h = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 279;
	ptr_struct->slicer_offset_cm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset = 263;
	ptr_struct->mixer_offset_cm0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset = 256;
	ptr_struct->common_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

}

void slrp_28nm_print(const struct slrp_28nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrp_28nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mix90phase           : " UH_FMT "\n", ptr_struct->mix90phase);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp90sel              : " UH_FMT "\n", ptr_struct->dp90sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_sel               : " UH_FMT "\n", ptr_struct->dp_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_sel               : " UH_FMT "\n", ptr_struct->ib_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap3             : " UH_FMT "\n", ptr_struct->ffe_tap3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap2             : " UH_FMT "\n", ptr_struct->ffe_tap2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap1             : " UH_FMT "\n", ptr_struct->ffe_tap1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap0             : " UH_FMT "\n", ptr_struct->ffe_tap0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap7             : " UH_FMT "\n", ptr_struct->ffe_tap7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap6             : " UH_FMT "\n", ptr_struct->ffe_tap6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap5             : " UH_FMT "\n", ptr_struct->ffe_tap5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap4             : " UH_FMT "\n", ptr_struct->ffe_tap4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap_en           : " UH_FMT "\n", ptr_struct->ffe_tap_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixerbias_tap_amp    : " UH_FMT "\n", ptr_struct->mixerbias_tap_amp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap8             : " UH_FMT "\n", ptr_struct->ffe_tap8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slicer_offset0       : " UH_FMT "\n", ptr_struct->slicer_offset0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap_offset1      : " UH_FMT "\n", ptr_struct->ffe_tap_offset1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap_offset0      : " UH_FMT "\n", ptr_struct->ffe_tap_offset0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset1        : " UH_FMT "\n", ptr_struct->mixer_offset1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset0        : " UH_FMT "\n", ptr_struct->mixer_offset0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixerbgn_refn        : " UH_FMT "\n", ptr_struct->mixerbgn_refn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixerbgn_refp        : " UH_FMT "\n", ptr_struct->mixerbgn_refp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixerbgn_inn         : " UH_FMT "\n", ptr_struct->mixerbgn_inn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixerbgn_inp         : " UH_FMT "\n", ptr_struct->mixerbgn_inp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset_cm1     : " UH_FMT "\n", ptr_struct->mixer_offset_cm1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lctrl_input          : " UH_FMT "\n", ptr_struct->lctrl_input);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slicer_gctrl         : " UH_FMT "\n", ptr_struct->slicer_gctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ref_mixer_vreg       : " UH_FMT "\n", ptr_struct->ref_mixer_vreg);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_slicer_lctrl_l   : " UH_FMT "\n", ptr_struct->sel_slicer_lctrl_l);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_slicer_lctrl_h   : " UH_FMT "\n", ptr_struct->sel_slicer_lctrl_h);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slicer_offset_cm     : " UH_FMT "\n", ptr_struct->slicer_offset_cm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset_cm0     : " UH_FMT "\n", ptr_struct->mixer_offset_cm0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "common_mode          : " UH_FMT "\n", ptr_struct->common_mode);

}

int slrp_28nm_size(void)
{
	return 36;
}

void slrp_28nm_dump(const struct slrp_28nm *ptr_struct, FILE *file)
{
	slrp_28nm_print(ptr_struct, file, 0);
}

void slrp_data_set_pack(const struct slrp_data_set *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 36; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 288, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void slrp_data_set_unpack(struct slrp_data_set *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 36; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 288, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void slrp_data_set_print(const struct slrp_data_set *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrp_data_set ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 36; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int slrp_data_set_size(void)
{
	return 36;
}

void slrp_data_set_dump(const struct slrp_data_set *ptr_struct, FILE *file)
{
	slrp_data_set_print(ptr_struct, file, 0);
}

void Description_Mode_Block_Element_pack(const struct Description_Mode_Block_Element *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->NumOfLFTables);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->LFTableSize);

}

void Description_Mode_Block_Element_unpack(struct Description_Mode_Block_Element *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 12;
	ptr_struct->NumOfLFTables = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 2;
	ptr_struct->LFTableSize = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

}

void Description_Mode_Block_Element_print(const struct Description_Mode_Block_Element *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== Description_Mode_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NumOfLFTables        : " UH_FMT "\n", ptr_struct->NumOfLFTables);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LFTableSize          : " UH_FMT "\n", ptr_struct->LFTableSize);

}

int Description_Mode_Block_Element_size(void)
{
	return 2;
}

void Description_Mode_Block_Element_dump(const struct Description_Mode_Block_Element *ptr_struct, FILE *file)
{
	Description_Mode_Block_Element_print(ptr_struct, file, 0);
}

void LFT_Priv_Block_Element_pack(const struct LFT_Priv_Block_Element *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->FDB_LID_Offset);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->FDB_LID_Space);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->FDB_Table_IX);

}

void LFT_Priv_Block_Element_unpack(struct LFT_Priv_Block_Element *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	ptr_struct->FDB_LID_Offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 8;
	ptr_struct->FDB_LID_Space = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->FDB_Table_IX = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void LFT_Priv_Block_Element_print(const struct LFT_Priv_Block_Element *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== LFT_Priv_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDB_LID_Offset       : " UH_FMT "\n", ptr_struct->FDB_LID_Offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDB_LID_Space        : " UH_FMT "\n", ptr_struct->FDB_LID_Space);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDB_Table_IX         : " UH_FMT "\n", ptr_struct->FDB_Table_IX);

}

int LFT_Priv_Block_Element_size(void)
{
	return 4;
}

void LFT_Priv_Block_Element_dump(const struct LFT_Priv_Block_Element *ptr_struct, FILE *file)
{
	LFT_Priv_Block_Element_print(ptr_struct, file, 0);
}

void LidPortMapping_Block_Element_pack(const struct LidPortMapping_Block_Element *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->GroupNumber);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->TableNumber);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->Reserved);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->LidState);

}

void LidPortMapping_Block_Element_unpack(struct LidPortMapping_Block_Element *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->GroupNumber = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->TableNumber = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 2;
	ptr_struct->Reserved = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 0;
	ptr_struct->LidState = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void LidPortMapping_Block_Element_print(const struct LidPortMapping_Block_Element *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== LidPortMapping_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "GroupNumber          : " UH_FMT "\n", ptr_struct->GroupNumber);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TableNumber          : " UH_FMT "\n", ptr_struct->TableNumber);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved             : " UH_FMT "\n", ptr_struct->Reserved);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LidState             : " UH_FMT "\n", ptr_struct->LidState);

}

int LidPortMapping_Block_Element_size(void)
{
	return 2;
}

void LidPortMapping_Block_Element_dump(const struct LidPortMapping_Block_Element *ptr_struct, FILE *file)
{
	LidPortMapping_Block_Element_print(ptr_struct, file, 0);
}

void LidPortMapping_Block_Element_SX_pack(const struct LidPortMapping_Block_Element_SX *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->GroupNumber);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Reserved_1);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->DefaultPort);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->TableNumber);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->Reserved_2);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->LidState);

}

void LidPortMapping_Block_Element_SX_unpack(struct LidPortMapping_Block_Element_SX *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	ptr_struct->GroupNumber = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 16;
	ptr_struct->Reserved_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 8;
	ptr_struct->DefaultPort = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->TableNumber = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 2;
	ptr_struct->Reserved_2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 0;
	ptr_struct->LidState = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void LidPortMapping_Block_Element_SX_print(const struct LidPortMapping_Block_Element_SX *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== LidPortMapping_Block_Element_SX ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "GroupNumber          : " UH_FMT "\n", ptr_struct->GroupNumber);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved_1           : " UH_FMT "\n", ptr_struct->Reserved_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DefaultPort          : " UH_FMT "\n", ptr_struct->DefaultPort);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TableNumber          : " UH_FMT "\n", ptr_struct->TableNumber);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved_2           : " UH_FMT "\n", ptr_struct->Reserved_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LidState             : " UH_FMT "\n", ptr_struct->LidState);

}

int LidPortMapping_Block_Element_SX_size(void)
{
	return 4;
}

void LidPortMapping_Block_Element_SX_dump(const struct LidPortMapping_Block_Element_SX *ptr_struct, FILE *file)
{
	LidPortMapping_Block_Element_SX_print(ptr_struct, file, 0);
}

void PLFT_Entry_Block_Element_pack(const struct PLFT_Entry_Block_Element *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->PortNumSize);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SharedLFTPortNum);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortNum);

}

void PLFT_Entry_Block_Element_unpack(struct PLFT_Entry_Block_Element *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	ptr_struct->PortNumSize = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 8;
	ptr_struct->SharedLFTPortNum = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->PortNum = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void PLFT_Entry_Block_Element_print(const struct PLFT_Entry_Block_Element *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PLFT_Entry_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortNumSize          : " UH_FMT "\n", ptr_struct->PortNumSize);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SharedLFTPortNum     : " UH_FMT "\n", ptr_struct->SharedLFTPortNum);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortNum              : " UH_FMT "\n", ptr_struct->PortNum);

}

int PLFT_Entry_Block_Element_size(void)
{
	return 4;
}

void PLFT_Entry_Block_Element_dump(const struct PLFT_Entry_Block_Element *ptr_struct, FILE *file)
{
	PLFT_Entry_Block_Element_print(ptr_struct, file, 0);
}

void PortGroup_Block_Element_pack(const struct PortGroup_Block_Element *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->SubGroup_3);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->SubGroup_2);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->SubGroup_1);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->SubGroup_0);

}

void PortGroup_Block_Element_unpack(struct PortGroup_Block_Element *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->SubGroup_3 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->SubGroup_2 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->SubGroup_1 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->SubGroup_0 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void PortGroup_Block_Element_print(const struct PortGroup_Block_Element *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PortGroup_Block_Element ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SubGroup_3           : " U64H_FMT "\n", ptr_struct->SubGroup_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SubGroup_2           : " U64H_FMT "\n", ptr_struct->SubGroup_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SubGroup_1           : " U64H_FMT "\n", ptr_struct->SubGroup_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SubGroup_0           : " U64H_FMT "\n", ptr_struct->SubGroup_0);

}

int PortGroup_Block_Element_size(void)
{
	return 32;
}

void PortGroup_Block_Element_dump(const struct PortGroup_Block_Element *ptr_struct, FILE *file)
{
	PortGroup_Block_Element_print(ptr_struct, file, 0);
}

void PortSLToPLFT_pack(const struct PortSLToPLFT *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL3);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL2);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL1);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL0);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL7);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL6);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL5);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL4);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL11);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL10);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL9);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL8);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL15);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL14);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL13);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PLFTToPortSL12);

}

void PortSLToPLFT_unpack(struct PortSLToPLFT *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->PLFTToPortSL3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->PLFTToPortSL2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->PLFTToPortSL1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->PLFTToPortSL0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 56;
	ptr_struct->PLFTToPortSL7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->PLFTToPortSL6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->PLFTToPortSL5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->PLFTToPortSL4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->PLFTToPortSL11 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->PLFTToPortSL10 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->PLFTToPortSL9 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->PLFTToPortSL8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 120;
	ptr_struct->PLFTToPortSL15 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->PLFTToPortSL14 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->PLFTToPortSL13 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->PLFTToPortSL12 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void PortSLToPLFT_print(const struct PortSLToPLFT *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PortSLToPLFT ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL3        : " UH_FMT "\n", ptr_struct->PLFTToPortSL3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL2        : " UH_FMT "\n", ptr_struct->PLFTToPortSL2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL1        : " UH_FMT "\n", ptr_struct->PLFTToPortSL1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL0        : " UH_FMT "\n", ptr_struct->PLFTToPortSL0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL7        : " UH_FMT "\n", ptr_struct->PLFTToPortSL7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL6        : " UH_FMT "\n", ptr_struct->PLFTToPortSL6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL5        : " UH_FMT "\n", ptr_struct->PLFTToPortSL5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL4        : " UH_FMT "\n", ptr_struct->PLFTToPortSL4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL11       : " UH_FMT "\n", ptr_struct->PLFTToPortSL11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL10       : " UH_FMT "\n", ptr_struct->PLFTToPortSL10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL9        : " UH_FMT "\n", ptr_struct->PLFTToPortSL9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL8        : " UH_FMT "\n", ptr_struct->PLFTToPortSL8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL15       : " UH_FMT "\n", ptr_struct->PLFTToPortSL15);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL14       : " UH_FMT "\n", ptr_struct->PLFTToPortSL14);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL13       : " UH_FMT "\n", ptr_struct->PLFTToPortSL13);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PLFTToPortSL12       : " UH_FMT "\n", ptr_struct->PLFTToPortSL12);

}

int PortSLToPLFT_size(void)
{
	return 16;
}

void PortSLToPLFT_dump(const struct PortSLToPLFT *ptr_struct, FILE *file)
{
	PortSLToPLFT_print(ptr_struct, file, 0);
}

void ctle_calib_set_pack(const struct ctle_calib_set *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->bgn_offset_n0);

	offset = 19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->bgn_offset_p0);

	offset = 11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->bgn_offset_n1);

	offset = 3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->bgn_offset_p1);

}

void ctle_calib_set_unpack(struct ctle_calib_set *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 27;
	ptr_struct->bgn_offset_n0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 19;
	ptr_struct->bgn_offset_p0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 11;
	ptr_struct->bgn_offset_n1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 3;
	ptr_struct->bgn_offset_p1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

}

void ctle_calib_set_print(const struct ctle_calib_set *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ctle_calib_set ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bgn_offset_n0        : " UH_FMT "\n", ptr_struct->bgn_offset_n0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bgn_offset_p0        : " UH_FMT "\n", ptr_struct->bgn_offset_p0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bgn_offset_n1        : " UH_FMT "\n", ptr_struct->bgn_offset_n1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bgn_offset_p1        : " UH_FMT "\n", ptr_struct->bgn_offset_p1);

}

int ctle_calib_set_size(void)
{
	return 4;
}

void ctle_calib_set_dump(const struct ctle_calib_set *ptr_struct, FILE *file)
{
	ctle_calib_set_print(ptr_struct, file, 0);
}

void pll_status_pack(const union pll_status *ptr_struct, u_int8_t *ptr_buff)
{
	pll_status_data_pack(&(ptr_struct->pll_status_data), ptr_buff);
}

void pll_status_unpack(union pll_status *ptr_struct, const u_int8_t *ptr_buff)
{
	pll_status_data_unpack(&(ptr_struct->pll_status_data), ptr_buff);
}

void pll_status_print(const union pll_status *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pll_status ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_status_28nm:\n");
	pll_status_28nm_print(&(ptr_struct->pll_status_28nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_status_16nm:\n");
	pll_status_16nm_print(&(ptr_struct->pll_status_16nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_status_data:\n");
	pll_status_data_print(&(ptr_struct->pll_status_data), file, indent_level + 1);

}

int pll_status_size(void)
{
	return 8;
}

void pll_status_dump(const union pll_status *ptr_struct, FILE *file)
{
	pll_status_print(ptr_struct, file, 0);
}

void psu_status_pack(const struct psu_status *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ac_status);

	offset = 26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->dc_status);

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->alert);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->present);

	offset = 62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->fan);

	offset = 58;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->temp);

	offset = 127;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->snp);

	for (i = 0; i < 24; i++) {
	offset = adb2c_calc_array_field_address(152, 8, i, 640, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->serial_number[i]);
	}

}

void psu_status_unpack(struct psu_status *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	ptr_struct->ac_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 26;
	ptr_struct->dc_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 6;
	ptr_struct->alert = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 0;
	ptr_struct->present = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 62;
	ptr_struct->fan = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 58;
	ptr_struct->temp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 127;
	ptr_struct->snp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	for (i = 0; i < 24; i++) {
	offset = adb2c_calc_array_field_address(152, 8, i, 640, 1);
	ptr_struct->serial_number[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->serial_number[24] = '\0';
}

void psu_status_print(const struct psu_status *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== psu_status ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ac_status            : " UH_FMT "\n", ptr_struct->ac_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_status            : " UH_FMT "\n", ptr_struct->dc_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "alert                : " UH_FMT "\n", ptr_struct->alert);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "present              : " UH_FMT "\n", ptr_struct->present);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fan                  : " UH_FMT "\n", ptr_struct->fan);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temp                 : " UH_FMT "\n", ptr_struct->temp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snp                  : " UH_FMT "\n", ptr_struct->snp);

	fprintf(file, "serial_number        : \"%s\"\n", ptr_struct->serial_number);
}

int psu_status_size(void)
{
	return 80;
}

void psu_status_dump(const struct psu_status *ptr_struct, FILE *file)
{
	psu_status_print(ptr_struct, file, 0);
}

void slrg_data_pack(const union slrg_data *ptr_struct, u_int8_t *ptr_buff)
{
	slrg_data_set_pack(&(ptr_struct->slrg_data_set), ptr_buff);
}

void slrg_data_unpack(union slrg_data *ptr_struct, const u_int8_t *ptr_buff)
{
	slrg_data_set_unpack(&(ptr_struct->slrg_data_set), ptr_buff);
}

void slrg_data_print(const union slrg_data *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrg_data ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrg_28nm:\n");
	slrg_28nm_print(&(ptr_struct->slrg_28nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrg_16nm:\n");
	slrg_16nm_print(&(ptr_struct->slrg_16nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrg_data_set:\n");
	slrg_data_set_print(&(ptr_struct->slrg_data_set), file, indent_level + 1);

}

int slrg_data_size(void)
{
	return 36;
}

void slrg_data_dump(const union slrg_data *ptr_struct, FILE *file)
{
	slrg_data_print(ptr_struct, file, 0);
}

void slrp_data_pack(const union slrp_data *ptr_struct, u_int8_t *ptr_buff)
{
	slrp_data_set_pack(&(ptr_struct->slrp_data_set), ptr_buff);
}

void slrp_data_unpack(union slrp_data *ptr_struct, const u_int8_t *ptr_buff)
{
	slrp_data_set_unpack(&(ptr_struct->slrp_data_set), ptr_buff);
}

void slrp_data_print(const union slrp_data *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrp_data ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrp_28nm:\n");
	slrp_28nm_print(&(ptr_struct->slrp_28nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrp_16nm:\n");
	slrp_16nm_print(&(ptr_struct->slrp_16nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrp_data_set:\n");
	slrp_data_set_print(&(ptr_struct->slrp_data_set), file, indent_level + 1);

}

int slrp_data_size(void)
{
	return 36;
}

void slrp_data_dump(const union slrp_data *ptr_struct, FILE *file)
{
	slrp_data_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Addr_0_47_pack(const struct CableInfo_Payload_Addr_0_47 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->CDRTXRXLossIndicator);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->RevisionComplaince);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Identifier);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->VoltageAlarmAndWarning);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->TemperatureAlarmandWarning);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->TXRXLOLIndicator);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AdaptiveEqualizationFault);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->TXBiasAlarmAndWarningHigh);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->RXPowerAlarmAndWarning);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->TXPowerAlarmAndWarning);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->TXBiasAlarmAndWarningLow);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagDeviceTemperature);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagSupplyVoltage);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagRX1Power);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagRX3Power);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagRX2Power);

	offset = 336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagTX1Bias);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagRX4Power);

	offset = 368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagTX3Bias);

	offset = 352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagTX2Bias);

}

void CableInfo_Payload_Addr_0_47_unpack(struct CableInfo_Payload_Addr_0_47 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->CDRTXRXLossIndicator = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->RevisionComplaince = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->Identifier = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 56;
	ptr_struct->VoltageAlarmAndWarning = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->TemperatureAlarmandWarning = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->TXRXLOLIndicator = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->AdaptiveEqualizationFault = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->TXBiasAlarmAndWarningHigh = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->RXPowerAlarmAndWarning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 104;
	ptr_struct->TXPowerAlarmAndWarning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->TXBiasAlarmAndWarningLow = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 176;
	ptr_struct->DiagDeviceTemperature = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 208;
	ptr_struct->DiagSupplyVoltage = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 272;
	ptr_struct->DiagRX1Power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 304;
	ptr_struct->DiagRX3Power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 288;
	ptr_struct->DiagRX2Power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 336;
	ptr_struct->DiagTX1Bias = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 320;
	ptr_struct->DiagRX4Power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 368;
	ptr_struct->DiagTX3Bias = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 352;
	ptr_struct->DiagTX2Bias = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void CableInfo_Payload_Addr_0_47_print(const struct CableInfo_Payload_Addr_0_47 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Addr_0_47 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CDRTXRXLossIndicator : " UH_FMT "\n", ptr_struct->CDRTXRXLossIndicator);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RevisionComplaince   : " UH_FMT "\n", ptr_struct->RevisionComplaince);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Identifier           : " UH_FMT "\n", ptr_struct->Identifier);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VoltageAlarmAndWarning : " UH_FMT "\n", ptr_struct->VoltageAlarmAndWarning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TemperatureAlarmandWarning : " UH_FMT "\n", ptr_struct->TemperatureAlarmandWarning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXRXLOLIndicator     : " UH_FMT "\n", ptr_struct->TXRXLOLIndicator);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AdaptiveEqualizationFault : " UH_FMT "\n", ptr_struct->AdaptiveEqualizationFault);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXBiasAlarmAndWarningHigh : " UH_FMT "\n", ptr_struct->TXBiasAlarmAndWarningHigh);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RXPowerAlarmAndWarning : " UH_FMT "\n", ptr_struct->RXPowerAlarmAndWarning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXPowerAlarmAndWarning : " UH_FMT "\n", ptr_struct->TXPowerAlarmAndWarning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXBiasAlarmAndWarningLow : " UH_FMT "\n", ptr_struct->TXBiasAlarmAndWarningLow);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagDeviceTemperature : " UH_FMT "\n", ptr_struct->DiagDeviceTemperature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagSupplyVoltage    : " UH_FMT "\n", ptr_struct->DiagSupplyVoltage);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagRX1Power         : " UH_FMT "\n", ptr_struct->DiagRX1Power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagRX3Power         : " UH_FMT "\n", ptr_struct->DiagRX3Power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagRX2Power         : " UH_FMT "\n", ptr_struct->DiagRX2Power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagTX1Bias          : " UH_FMT "\n", ptr_struct->DiagTX1Bias);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagRX4Power         : " UH_FMT "\n", ptr_struct->DiagRX4Power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagTX3Bias          : " UH_FMT "\n", ptr_struct->DiagTX3Bias);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagTX2Bias          : " UH_FMT "\n", ptr_struct->DiagTX2Bias);

}

int CableInfo_Payload_Addr_0_47_size(void)
{
	return 48;
}

void CableInfo_Payload_Addr_0_47_dump(const struct CableInfo_Payload_Addr_0_47 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Addr_0_47_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Addr_128_167_pack(const struct CableInfo_Payload_Addr_128_167 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecCompliance0);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Connector);

	offset = 14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ExtPowerClass);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->CdrPresent);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PowerClass);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Identifier);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecCompliance4);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecCompliance3);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecCompliance2);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecCompliance1);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Encoding);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecCompliance7);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecCompliance6);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecCompliance5);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LengthOM3);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LengthSMFiber);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ExtendedRateSelect);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->BRNominal);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->DeviceTech);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LengthCopperOrActive);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LengthOM1);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LengthOM2);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(184, 8, i, 384, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->VendorName[i]);
	}

	offset = 296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->VendorOUI);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ExtendedModuleCodes);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->NotUsed);

}

void CableInfo_Payload_Addr_128_167_unpack(struct CableInfo_Payload_Addr_128_167 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->SpecCompliance0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->Connector = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 14;
	ptr_struct->ExtPowerClass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 12;
	ptr_struct->CdrPresent = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->PowerClass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 0;
	ptr_struct->Identifier = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 56;
	ptr_struct->SpecCompliance4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->SpecCompliance3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->SpecCompliance2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->SpecCompliance1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->Encoding = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->SpecCompliance7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->SpecCompliance6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->SpecCompliance5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 120;
	ptr_struct->LengthOM3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->LengthSMFiber = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->ExtendedRateSelect = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->BRNominal = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 152;
	ptr_struct->DeviceTech = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->LengthCopperOrActive = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 136;
	ptr_struct->LengthOM1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->LengthOM2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(184, 8, i, 384, 1);
	ptr_struct->VendorName[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->VendorName[16] = '\0';
	offset = 296;
	ptr_struct->VendorOUI = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 288;
	ptr_struct->ExtendedModuleCodes = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 320;
	ptr_struct->NotUsed = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void CableInfo_Payload_Addr_128_167_print(const struct CableInfo_Payload_Addr_128_167 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Addr_128_167 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecCompliance0      : " UH_FMT "\n", ptr_struct->SpecCompliance0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Connector            : " UH_FMT "\n", ptr_struct->Connector);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ExtPowerClass        : " UH_FMT "\n", ptr_struct->ExtPowerClass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CdrPresent           : " UH_FMT "\n", ptr_struct->CdrPresent);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PowerClass           : " UH_FMT "\n", ptr_struct->PowerClass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Identifier           : " UH_FMT "\n", ptr_struct->Identifier);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecCompliance4      : " UH_FMT "\n", ptr_struct->SpecCompliance4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecCompliance3      : " UH_FMT "\n", ptr_struct->SpecCompliance3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecCompliance2      : " UH_FMT "\n", ptr_struct->SpecCompliance2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecCompliance1      : " UH_FMT "\n", ptr_struct->SpecCompliance1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Encoding             : " UH_FMT "\n", ptr_struct->Encoding);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecCompliance7      : " UH_FMT "\n", ptr_struct->SpecCompliance7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecCompliance6      : " UH_FMT "\n", ptr_struct->SpecCompliance6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecCompliance5      : " UH_FMT "\n", ptr_struct->SpecCompliance5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LengthOM3            : " UH_FMT "\n", ptr_struct->LengthOM3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LengthSMFiber        : " UH_FMT "\n", ptr_struct->LengthSMFiber);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ExtendedRateSelect   : " UH_FMT "\n", ptr_struct->ExtendedRateSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "BRNominal            : " UH_FMT "\n", ptr_struct->BRNominal);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DeviceTech           : " UH_FMT "\n", ptr_struct->DeviceTech);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LengthCopperOrActive : " UH_FMT "\n", ptr_struct->LengthCopperOrActive);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LengthOM1            : " UH_FMT "\n", ptr_struct->LengthOM1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LengthOM2            : " UH_FMT "\n", ptr_struct->LengthOM2);

	fprintf(file, "VendorName           : \"%s\"\n", ptr_struct->VendorName);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VendorOUI            : " UH_FMT "\n", ptr_struct->VendorOUI);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ExtendedModuleCodes  : " UH_FMT "\n", ptr_struct->ExtendedModuleCodes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NotUsed              : " U64H_FMT "\n", ptr_struct->NotUsed);

}

int CableInfo_Payload_Addr_128_167_size(void)
{
	return 48;
}

void CableInfo_Payload_Addr_128_167_dump(const struct CableInfo_Payload_Addr_128_167 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Addr_128_167_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Addr_168_211_pack(const struct CableInfo_Payload_Addr_168_211 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 384, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->VendorPN[i]);
	}

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Attenuation_5g);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Attenuation_2_5g);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(152, 8, i, 384, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->VendorRev[i]);
	}

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Attenuation_12g);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Attenuation_7g);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->QSFPOptions);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->EthComCodesExt);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(248, 8, i, 384, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->VendorSN[i]);
	}

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->NotUsed);

}

void CableInfo_Payload_Addr_168_211_unpack(struct CableInfo_Payload_Addr_168_211 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 384, 1);
	ptr_struct->VendorPN[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->VendorPN[16] = '\0';
	offset = 152;
	ptr_struct->Attenuation_5g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->Attenuation_2_5g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(152, 8, i, 384, 1);
	ptr_struct->VendorRev[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->VendorRev[2] = '\0';
	offset = 168;
	ptr_struct->Attenuation_12g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 160;
	ptr_struct->Attenuation_7g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 200;
	ptr_struct->QSFPOptions = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 192;
	ptr_struct->EthComCodesExt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(248, 8, i, 384, 1);
	ptr_struct->VendorSN[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->VendorSN[16] = '\0';
	offset = 352;
	ptr_struct->NotUsed = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void CableInfo_Payload_Addr_168_211_print(const struct CableInfo_Payload_Addr_168_211 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Addr_168_211 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	fprintf(file, "VendorPN             : \"%s\"\n", ptr_struct->VendorPN);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Attenuation_5g       : " UH_FMT "\n", ptr_struct->Attenuation_5g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Attenuation_2_5g     : " UH_FMT "\n", ptr_struct->Attenuation_2_5g);

	fprintf(file, "VendorRev            : \"%s\"\n", ptr_struct->VendorRev);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Attenuation_12g      : " UH_FMT "\n", ptr_struct->Attenuation_12g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Attenuation_7g       : " UH_FMT "\n", ptr_struct->Attenuation_7g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "QSFPOptions          : " UH_FMT "\n", ptr_struct->QSFPOptions);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "EthComCodesExt       : " UH_FMT "\n", ptr_struct->EthComCodesExt);

	fprintf(file, "VendorSN             : \"%s\"\n", ptr_struct->VendorSN);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NotUsed              : " U32H_FMT "\n", ptr_struct->NotUsed);

}

int CableInfo_Payload_Addr_168_211_size(void)
{
	return 48;
}

void CableInfo_Payload_Addr_168_211_dump(const struct CableInfo_Payload_Addr_168_211 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Addr_168_211_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Addr_212_255_pack(const struct CableInfo_Payload_Addr_212_255 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 384, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->DateCode[i]);
	}

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->NominalBr_250);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->DDMIType);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(120, 8, i, 384, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->MlnxSFGSN[i]);
	}

	offset = 312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->MlnxVendorByte);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->MlnxRevision);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->MellanoxCap);

}

void CableInfo_Payload_Addr_212_255_unpack(struct CableInfo_Payload_Addr_212_255 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 384, 1);
	ptr_struct->DateCode[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->DateCode[8] = '\0';
	offset = 80;
	ptr_struct->NominalBr_250 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->DDMIType = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(120, 8, i, 384, 1);
	ptr_struct->MlnxSFGSN[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->MlnxSFGSN[16] = '\0';
	offset = 312;
	ptr_struct->MlnxVendorByte = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 304;
	ptr_struct->MlnxRevision = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 320;
	ptr_struct->MellanoxCap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void CableInfo_Payload_Addr_212_255_print(const struct CableInfo_Payload_Addr_212_255 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Addr_212_255 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	fprintf(file, "DateCode             : \"%s\"\n", ptr_struct->DateCode);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NominalBr_250        : " UH_FMT "\n", ptr_struct->NominalBr_250);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DDMIType             : " UH_FMT "\n", ptr_struct->DDMIType);

	fprintf(file, "MlnxSFGSN            : \"%s\"\n", ptr_struct->MlnxSFGSN);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MlnxVendorByte       : " UH_FMT "\n", ptr_struct->MlnxVendorByte);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MlnxRevision         : " UH_FMT "\n", ptr_struct->MlnxRevision);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MellanoxCap          : " UH_FMT "\n", ptr_struct->MellanoxCap);

}

int CableInfo_Payload_Addr_212_255_size(void)
{
	return 48;
}

void CableInfo_Payload_Addr_212_255_dump(const struct CableInfo_Payload_Addr_212_255 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Addr_212_255_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Addr_48_79_pack(const struct CableInfo_Payload_Addr_48_79 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagTX1Power);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagTX4Bias);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagTX3Power);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagTX2Power);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ReservedSet4_1);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagTX4Power);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ReservedSet4_2);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ReservedSet5_1);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ReservedSet4_3);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ReservedSet5_2);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->VendorSpecific_1);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ReservedSet5_3);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VendorSpecific_2);

}

void CableInfo_Payload_Addr_48_79_unpack(struct CableInfo_Payload_Addr_48_79 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->DiagTX1Power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->DiagTX4Bias = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->DiagTX3Power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->DiagTX2Power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->ReservedSet4_1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->DiagTX4Power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->ReservedSet4_2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 144;
	ptr_struct->ReservedSet5_1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->ReservedSet4_3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->ReservedSet5_2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 208;
	ptr_struct->VendorSpecific_1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->ReservedSet5_3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->VendorSpecific_2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void CableInfo_Payload_Addr_48_79_print(const struct CableInfo_Payload_Addr_48_79 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Addr_48_79 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagTX1Power         : " UH_FMT "\n", ptr_struct->DiagTX1Power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagTX4Bias          : " UH_FMT "\n", ptr_struct->DiagTX4Bias);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagTX3Power         : " UH_FMT "\n", ptr_struct->DiagTX3Power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagTX2Power         : " UH_FMT "\n", ptr_struct->DiagTX2Power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ReservedSet4_1       : " UH_FMT "\n", ptr_struct->ReservedSet4_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagTX4Power         : " UH_FMT "\n", ptr_struct->DiagTX4Power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ReservedSet4_2       : " U32H_FMT "\n", ptr_struct->ReservedSet4_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ReservedSet5_1       : " UH_FMT "\n", ptr_struct->ReservedSet5_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ReservedSet4_3       : " UH_FMT "\n", ptr_struct->ReservedSet4_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ReservedSet5_2       : " U32H_FMT "\n", ptr_struct->ReservedSet5_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VendorSpecific_1     : " UH_FMT "\n", ptr_struct->VendorSpecific_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ReservedSet5_3       : " UH_FMT "\n", ptr_struct->ReservedSet5_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VendorSpecific_2     : " U32H_FMT "\n", ptr_struct->VendorSpecific_2);

}

int CableInfo_Payload_Addr_48_79_size(void)
{
	return 32;
}

void CableInfo_Payload_Addr_48_79_dump(const struct CableInfo_Payload_Addr_48_79 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Addr_48_79_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Addr_80_127_pack(const struct CableInfo_Payload_Addr_80_127 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->TXDisable);

	offset = 109;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->HighPower);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->CdrControl);

	offset = 264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->QSFPConnectivity);

}

void CableInfo_Payload_Addr_80_127_unpack(struct CableInfo_Payload_Addr_80_127 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 52;
	ptr_struct->TXDisable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 109;
	ptr_struct->HighPower = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 144;
	ptr_struct->CdrControl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 264;
	ptr_struct->QSFPConnectivity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void CableInfo_Payload_Addr_80_127_print(const struct CableInfo_Payload_Addr_80_127 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Addr_80_127 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXDisable            : " UH_FMT "\n", ptr_struct->TXDisable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HighPower            : " UH_FMT "\n", ptr_struct->HighPower);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CdrControl           : " UH_FMT "\n", ptr_struct->CdrControl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "QSFPConnectivity     : " UH_FMT "\n", ptr_struct->QSFPConnectivity);

}

int CableInfo_Payload_Addr_80_127_size(void)
{
	return 48;
}

void CableInfo_Payload_Addr_80_127_dump(const struct CableInfo_Payload_Addr_80_127 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Addr_80_127_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Page_3_Addr_212_255_pack(const struct CableInfo_Payload_Page_3_Addr_212_255 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->OutputAmpCap);

	offset = 138;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->OutputEmpType);

	offset = 132;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->OutputEmpCap);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->InputEqCap);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->InputEq);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->TXAdaptiveEqualizationFreeze);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->OutputAmp);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->OutputEmp);

	offset = 232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AdaptiveEqControl);

}

void CableInfo_Payload_Page_3_Addr_212_255_unpack(struct CableInfo_Payload_Page_3_Addr_212_255 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 140;
	ptr_struct->OutputAmpCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 138;
	ptr_struct->OutputEmpType = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 132;
	ptr_struct->OutputEmpCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->InputEqCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 176;
	ptr_struct->InputEq = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 168;
	ptr_struct->TXAdaptiveEqualizationFreeze = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 208;
	ptr_struct->OutputAmp = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->OutputEmp = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 232;
	ptr_struct->AdaptiveEqControl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void CableInfo_Payload_Page_3_Addr_212_255_print(const struct CableInfo_Payload_Page_3_Addr_212_255 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Page_3_Addr_212_255 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OutputAmpCap         : " UH_FMT "\n", ptr_struct->OutputAmpCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OutputEmpType        : " UH_FMT "\n", ptr_struct->OutputEmpType);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OutputEmpCap         : " UH_FMT "\n", ptr_struct->OutputEmpCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "InputEqCap           : " UH_FMT "\n", ptr_struct->InputEqCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "InputEq              : " UH_FMT "\n", ptr_struct->InputEq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXAdaptiveEqualizationFreeze : " UH_FMT "\n", ptr_struct->TXAdaptiveEqualizationFreeze);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OutputAmp            : " UH_FMT "\n", ptr_struct->OutputAmp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OutputEmp            : " UH_FMT "\n", ptr_struct->OutputEmp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AdaptiveEqControl    : " UH_FMT "\n", ptr_struct->AdaptiveEqControl);

}

int CableInfo_Payload_Page_3_Addr_212_255_size(void)
{
	return 48;
}

void CableInfo_Payload_Page_3_Addr_212_255_dump(const struct CableInfo_Payload_Page_3_Addr_212_255 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Page_3_Addr_212_255_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Page_E9_Addr_128_175_pack(const struct CableInfo_Payload_Page_E9_Addr_128_175 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(64, 16, i, 384, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_rssi_lane[i]);
	}

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->number_of_resets);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(128, 16, i, 384, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->min_rssi_lane[i]);
	}

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_temp_module);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_temp_vcsel);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->min_temp_module);

	offset = 280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->min_temp_vd);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->max_temp_vd);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->min_temp_vcsel);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vcsel_temp_hist_0_40);

	offset = 296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->min_temp_tia);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->max_temp_tia);

	offset = 336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vcsel_temp_hist_55_70);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vcsel_temp_hist_40_55);

	offset = 368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vcsel_temp_hist_85_100);

	offset = 352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vcsel_temp_hist_70_85);

}

void CableInfo_Payload_Page_E9_Addr_128_175_unpack(struct CableInfo_Payload_Page_E9_Addr_128_175 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(64, 16, i, 384, 1);
	ptr_struct->max_rssi_lane[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

	offset = 64;
	ptr_struct->number_of_resets = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(128, 16, i, 384, 1);
	ptr_struct->min_rssi_lane[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

	offset = 208;
	ptr_struct->max_temp_module = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 240;
	ptr_struct->max_temp_vcsel = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->min_temp_module = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 280;
	ptr_struct->min_temp_vd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 272;
	ptr_struct->max_temp_vd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 256;
	ptr_struct->min_temp_vcsel = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 304;
	ptr_struct->vcsel_temp_hist_0_40 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 296;
	ptr_struct->min_temp_tia = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 288;
	ptr_struct->max_temp_tia = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 336;
	ptr_struct->vcsel_temp_hist_55_70 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 320;
	ptr_struct->vcsel_temp_hist_40_55 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 368;
	ptr_struct->vcsel_temp_hist_85_100 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 352;
	ptr_struct->vcsel_temp_hist_70_85 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void CableInfo_Payload_Page_E9_Addr_128_175_print(const struct CableInfo_Payload_Page_E9_Addr_128_175 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Page_E9_Addr_128_175 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_rssi_lane_%03d   : " UH_FMT "\n", i, ptr_struct->max_rssi_lane[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "number_of_resets     : " UH_FMT "\n", ptr_struct->number_of_resets);

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_rssi_lane_%03d   : " UH_FMT "\n", i, ptr_struct->min_rssi_lane[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_temp_module      : " UH_FMT "\n", ptr_struct->max_temp_module);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_temp_vcsel       : " UH_FMT "\n", ptr_struct->max_temp_vcsel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_temp_module      : " UH_FMT "\n", ptr_struct->min_temp_module);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_temp_vd          : " UH_FMT "\n", ptr_struct->min_temp_vd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_temp_vd          : " UH_FMT "\n", ptr_struct->max_temp_vd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_temp_vcsel       : " UH_FMT "\n", ptr_struct->min_temp_vcsel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vcsel_temp_hist_0_40 : " UH_FMT "\n", ptr_struct->vcsel_temp_hist_0_40);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_temp_tia         : " UH_FMT "\n", ptr_struct->min_temp_tia);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_temp_tia         : " UH_FMT "\n", ptr_struct->max_temp_tia);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vcsel_temp_hist_55_70 : " UH_FMT "\n", ptr_struct->vcsel_temp_hist_55_70);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vcsel_temp_hist_40_55 : " UH_FMT "\n", ptr_struct->vcsel_temp_hist_40_55);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vcsel_temp_hist_85_100 : " UH_FMT "\n", ptr_struct->vcsel_temp_hist_85_100);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vcsel_temp_hist_70_85 : " UH_FMT "\n", ptr_struct->vcsel_temp_hist_70_85);

}

int CableInfo_Payload_Page_E9_Addr_128_175_size(void)
{
	return 48;
}

void CableInfo_Payload_Page_E9_Addr_128_175_dump(const struct CableInfo_Payload_Page_E9_Addr_128_175 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Page_E9_Addr_128_175_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Page_E9_Addr_176_211_pack(const struct CableInfo_Payload_Page_E9_Addr_176_211 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 288, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->bias_counter[i]);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(80, 16, i, 288, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mod_counter[i]);
	}

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->min_vcc_tx);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_vcc_tx);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->min_vcc_rx);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_vcc_rx);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->min_vcc_bu);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_vcc_bu);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->min_vcc_sd);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_vcc_sd);

}

void CableInfo_Payload_Page_E9_Addr_176_211_unpack(struct CableInfo_Payload_Page_E9_Addr_176_211 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 288, 1);
	ptr_struct->bias_counter[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(80, 16, i, 288, 1);
	ptr_struct->mod_counter[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

	offset = 144;
	ptr_struct->min_vcc_tx = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->max_vcc_tx = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 176;
	ptr_struct->min_vcc_rx = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->max_vcc_rx = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 208;
	ptr_struct->min_vcc_bu = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->max_vcc_bu = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 240;
	ptr_struct->min_vcc_sd = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->max_vcc_sd = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void CableInfo_Payload_Page_E9_Addr_176_211_print(const struct CableInfo_Payload_Page_E9_Addr_176_211 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Page_E9_Addr_176_211 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bias_counter_%03d    : " UH_FMT "\n", i, ptr_struct->bias_counter[i]);
	}

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mod_counter_%03d     : " UH_FMT "\n", i, ptr_struct->mod_counter[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_vcc_tx           : " UH_FMT "\n", ptr_struct->min_vcc_tx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_vcc_tx           : " UH_FMT "\n", ptr_struct->max_vcc_tx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_vcc_rx           : " UH_FMT "\n", ptr_struct->min_vcc_rx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_vcc_rx           : " UH_FMT "\n", ptr_struct->max_vcc_rx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_vcc_bu           : " UH_FMT "\n", ptr_struct->min_vcc_bu);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_vcc_bu           : " UH_FMT "\n", ptr_struct->max_vcc_bu);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_vcc_sd           : " UH_FMT "\n", ptr_struct->min_vcc_sd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_vcc_sd           : " UH_FMT "\n", ptr_struct->max_vcc_sd);

}

int CableInfo_Payload_Page_E9_Addr_176_211_size(void)
{
	return 36;
}

void CableInfo_Payload_Page_E9_Addr_176_211_dump(const struct CableInfo_Payload_Page_E9_Addr_176_211 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Page_E9_Addr_176_211_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Page_F0_Addr_128_171_pack(const struct CableInfo_Payload_Page_F0_Addr_128_171 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(344, 8, i, 352, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->FWVersion[i]);
	}

}

void CableInfo_Payload_Page_F0_Addr_128_171_unpack(struct CableInfo_Payload_Page_F0_Addr_128_171 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(344, 8, i, 352, 1);
	ptr_struct->FWVersion[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->FWVersion[4] = '\0';
}

void CableInfo_Payload_Page_F0_Addr_128_171_print(const struct CableInfo_Payload_Page_F0_Addr_128_171 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Page_F0_Addr_128_171 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	fprintf(file, "FWVersion            : \"%s\"\n", ptr_struct->FWVersion);
}

int CableInfo_Payload_Page_F0_Addr_128_171_size(void)
{
	return 44;
}

void CableInfo_Payload_Page_F0_Addr_128_171_dump(const struct CableInfo_Payload_Page_F0_Addr_128_171 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Page_F0_Addr_128_171_print(ptr_struct, file, 0);
}

void DDLinkDownInfo_pack(const struct DDLinkDownInfo *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->down_blame);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_reason_opcode);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->remote_reason_opcode);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->e2e_reason_opcode);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ber_exp);

	offset = 148;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ber_mantissa);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->last_ber_exp);

	offset = 132;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->last_ber_mantissa);

	offset = 184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->max_ber_exp);

	offset = 180;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->max_ber_mantissa);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->min_ber_exp);

	offset = 164;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->min_ber_mantissa);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_of_ber_alarams);

}

void DDLinkDownInfo_unpack(struct DDLinkDownInfo *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->down_blame = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 56;
	ptr_struct->local_reason_opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->remote_reason_opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 120;
	ptr_struct->e2e_reason_opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 152;
	ptr_struct->ber_exp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 148;
	ptr_struct->ber_mantissa = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 136;
	ptr_struct->last_ber_exp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 132;
	ptr_struct->last_ber_mantissa = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 184;
	ptr_struct->max_ber_exp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 180;
	ptr_struct->max_ber_mantissa = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 168;
	ptr_struct->min_ber_exp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 164;
	ptr_struct->min_ber_mantissa = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 208;
	ptr_struct->num_of_ber_alarams = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void DDLinkDownInfo_print(const struct DDLinkDownInfo *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DDLinkDownInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "down_blame           : " UH_FMT "\n", ptr_struct->down_blame);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_reason_opcode  : " UH_FMT "\n", ptr_struct->local_reason_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "remote_reason_opcode : " UH_FMT "\n", ptr_struct->remote_reason_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_reason_opcode    : " UH_FMT "\n", ptr_struct->e2e_reason_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_exp              : " UH_FMT "\n", ptr_struct->ber_exp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_mantissa         : " UH_FMT "\n", ptr_struct->ber_mantissa);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_ber_exp         : " UH_FMT "\n", ptr_struct->last_ber_exp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_ber_mantissa    : " UH_FMT "\n", ptr_struct->last_ber_mantissa);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_ber_exp          : " UH_FMT "\n", ptr_struct->max_ber_exp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_ber_mantissa     : " UH_FMT "\n", ptr_struct->max_ber_mantissa);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_ber_exp          : " UH_FMT "\n", ptr_struct->min_ber_exp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_ber_mantissa     : " UH_FMT "\n", ptr_struct->min_ber_mantissa);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_ber_alarams   : " UH_FMT "\n", ptr_struct->num_of_ber_alarams);

}

int DDLinkDownInfo_size(void)
{
	return 28;
}

void DDLinkDownInfo_dump(const struct DDLinkDownInfo *ptr_struct, FILE *file)
{
	DDLinkDownInfo_print(ptr_struct, file, 0);
}

void DDModuleInfo_pack(const struct DDModuleInfo *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ethernet_compliance_code);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ext_ethernet_compliance_code);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_breakout);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_technology);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_power_class);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_identifier);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_length);

	offset = 36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cable_vendor);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cable_type);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_tx_equalization);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_rx_emphasis);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_rx_amp);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_attenuation_5g);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_attenuation_7g);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_attenuation_12g);

	offset = 156;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_cdr_state);

	offset = 148;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rx_cdr_state);

	offset = 140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_cdr_cap);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rx_cdr_cap);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(184, 8, i, 1216, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vendor_name[i]);
	}

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(312, 8, i, 1216, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vendor_pn[i]);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(440, 8, i, 1216, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vendor_rev[i]);
	}

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fw_version);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(504, 8, i, 1216, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vendor_sn[i]);
	}

	offset = 624;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->voltage);

	offset = 608;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature);

	offset = 656;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane_1);

	offset = 640;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane_0);

	offset = 688;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane_3);

	offset = 672;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane_2);

	offset = 784;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane_1);

	offset = 768;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane_0);

	offset = 816;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane_3);

	offset = 800;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane_2);

	offset = 912;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane_1);

	offset = 896;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane_0);

	offset = 944;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane_3);

	offset = 928;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane_2);

	offset = 1040;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature_low_th);

	offset = 1024;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature_high_th);

	offset = 1072;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->voltage_low_th);

	offset = 1056;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->voltage_high_th);

	offset = 1104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_low_th);

	offset = 1088;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_high_th);

	offset = 1136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_low_th);

	offset = 1120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_high_th);

	offset = 1168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_low_th);

	offset = 1152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_high_th);

	offset = 1200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->wavelength);

}

void DDModuleInfo_unpack(struct DDModuleInfo *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->ethernet_compliance_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->ext_ethernet_compliance_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->cable_breakout = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->cable_technology = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 56;
	ptr_struct->cable_power_class = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->cable_identifier = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->cable_length = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 36;
	ptr_struct->cable_vendor = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->cable_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 88;
	ptr_struct->cable_tx_equalization = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->cable_rx_emphasis = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->cable_rx_amp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 120;
	ptr_struct->cable_attenuation_5g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->cable_attenuation_7g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->cable_attenuation_12g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 156;
	ptr_struct->tx_cdr_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 148;
	ptr_struct->rx_cdr_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 140;
	ptr_struct->tx_cdr_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 136;
	ptr_struct->rx_cdr_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(184, 8, i, 1216, 1);
	ptr_struct->vendor_name[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->vendor_name[16] = '\0';
	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(312, 8, i, 1216, 1);
	ptr_struct->vendor_pn[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->vendor_pn[16] = '\0';
	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(440, 8, i, 1216, 1);
	ptr_struct->vendor_rev[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->vendor_rev[4] = '\0';
	offset = 448;
	ptr_struct->fw_version = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(504, 8, i, 1216, 1);
	ptr_struct->vendor_sn[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->vendor_sn[16] = '\0';
	offset = 624;
	ptr_struct->voltage = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 608;
	ptr_struct->temperature = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 656;
	ptr_struct->rx_power_lane_1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 640;
	ptr_struct->rx_power_lane_0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 688;
	ptr_struct->rx_power_lane_3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 672;
	ptr_struct->rx_power_lane_2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 784;
	ptr_struct->tx_power_lane_1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 768;
	ptr_struct->tx_power_lane_0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 816;
	ptr_struct->tx_power_lane_3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 800;
	ptr_struct->tx_power_lane_2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 912;
	ptr_struct->tx_bias_lane_1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 896;
	ptr_struct->tx_bias_lane_0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 944;
	ptr_struct->tx_bias_lane_3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 928;
	ptr_struct->tx_bias_lane_2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1040;
	ptr_struct->temperature_low_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1024;
	ptr_struct->temperature_high_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1072;
	ptr_struct->voltage_low_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1056;
	ptr_struct->voltage_high_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1104;
	ptr_struct->rx_power_low_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1088;
	ptr_struct->rx_power_high_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1136;
	ptr_struct->tx_power_low_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1120;
	ptr_struct->tx_power_high_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1168;
	ptr_struct->tx_bias_low_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1152;
	ptr_struct->tx_bias_high_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1200;
	ptr_struct->wavelength = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void DDModuleInfo_print(const struct DDModuleInfo *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DDModuleInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ethernet_compliance_code : " UH_FMT "\n", ptr_struct->ethernet_compliance_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ext_ethernet_compliance_code : " UH_FMT "\n", ptr_struct->ext_ethernet_compliance_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_breakout       : " UH_FMT "\n", ptr_struct->cable_breakout);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_technology     : " UH_FMT "\n", ptr_struct->cable_technology);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_power_class    : " UH_FMT "\n", ptr_struct->cable_power_class);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_identifier     : " UH_FMT "\n", ptr_struct->cable_identifier);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_length         : " UH_FMT "\n", ptr_struct->cable_length);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_vendor         : " UH_FMT "\n", ptr_struct->cable_vendor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_type           : " UH_FMT "\n", ptr_struct->cable_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_tx_equalization : " UH_FMT "\n", ptr_struct->cable_tx_equalization);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_rx_emphasis    : " UH_FMT "\n", ptr_struct->cable_rx_emphasis);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_rx_amp         : " UH_FMT "\n", ptr_struct->cable_rx_amp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_attenuation_5g : " UH_FMT "\n", ptr_struct->cable_attenuation_5g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_attenuation_7g : " UH_FMT "\n", ptr_struct->cable_attenuation_7g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_attenuation_12g : " UH_FMT "\n", ptr_struct->cable_attenuation_12g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_cdr_state         : " UH_FMT "\n", ptr_struct->tx_cdr_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_cdr_state         : " UH_FMT "\n", ptr_struct->rx_cdr_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_cdr_cap           : " UH_FMT "\n", ptr_struct->tx_cdr_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_cdr_cap           : " UH_FMT "\n", ptr_struct->rx_cdr_cap);

	fprintf(file, "vendor_name          : \"%s\"\n", ptr_struct->vendor_name);
	fprintf(file, "vendor_pn            : \"%s\"\n", ptr_struct->vendor_pn);
	fprintf(file, "vendor_rev           : \"%s\"\n", ptr_struct->vendor_rev);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_version           : " U32H_FMT "\n", ptr_struct->fw_version);

	fprintf(file, "vendor_sn            : \"%s\"\n", ptr_struct->vendor_sn);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "voltage              : " UH_FMT "\n", ptr_struct->voltage);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature          : " UH_FMT "\n", ptr_struct->temperature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane_1      : " UH_FMT "\n", ptr_struct->rx_power_lane_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane_0      : " UH_FMT "\n", ptr_struct->rx_power_lane_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane_3      : " UH_FMT "\n", ptr_struct->rx_power_lane_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane_2      : " UH_FMT "\n", ptr_struct->rx_power_lane_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane_1      : " UH_FMT "\n", ptr_struct->tx_power_lane_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane_0      : " UH_FMT "\n", ptr_struct->tx_power_lane_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane_3      : " UH_FMT "\n", ptr_struct->tx_power_lane_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane_2      : " UH_FMT "\n", ptr_struct->tx_power_lane_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane_1       : " UH_FMT "\n", ptr_struct->tx_bias_lane_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane_0       : " UH_FMT "\n", ptr_struct->tx_bias_lane_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane_3       : " UH_FMT "\n", ptr_struct->tx_bias_lane_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane_2       : " UH_FMT "\n", ptr_struct->tx_bias_lane_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature_low_th   : " UH_FMT "\n", ptr_struct->temperature_low_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature_high_th  : " UH_FMT "\n", ptr_struct->temperature_high_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "voltage_low_th       : " UH_FMT "\n", ptr_struct->voltage_low_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "voltage_high_th      : " UH_FMT "\n", ptr_struct->voltage_high_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_low_th      : " UH_FMT "\n", ptr_struct->rx_power_low_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_high_th     : " UH_FMT "\n", ptr_struct->rx_power_high_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_low_th      : " UH_FMT "\n", ptr_struct->tx_power_low_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_high_th     : " UH_FMT "\n", ptr_struct->tx_power_high_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_low_th       : " UH_FMT "\n", ptr_struct->tx_bias_low_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_high_th      : " UH_FMT "\n", ptr_struct->tx_bias_high_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wavelength           : " UH_FMT "\n", ptr_struct->wavelength);

}

int DDModuleInfo_size(void)
{
	return 152;
}

void DDModuleInfo_dump(const struct DDModuleInfo *ptr_struct, FILE *file)
{
	DDModuleInfo_print(ptr_struct, file, 0);
}

void DDOperationInfo_pack(const struct DDOperationInfo *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->neg_mode_active);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->proto_active);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ib_phy_fsm_state);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eth_an_fsm_state);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phy_mngr_fsm_state);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->phy_manager_link_proto_enabled);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->phy_manager_link_width_enabled);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->core_to_phy_link_proto_enabled);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->core_to_phy_link_width_enabled);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cable_proto_cap);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->link_speed_active);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->link_width_active);

	offset = 220;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->loopback_mode);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->retran_mode_request);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->retran_mode_active);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->fec_mode_request);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->fec_mode_active);

	offset = 284;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->eth_100g_fec_support);

	offset = 280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->eth_25g_50g_fec_support);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->profile_fec_in_use);

}

void DDOperationInfo_unpack(struct DDOperationInfo *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 12;
	ptr_struct->neg_mode_active = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 8;
	ptr_struct->proto_active = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->ib_phy_fsm_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->eth_an_fsm_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->phy_mngr_fsm_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->phy_manager_link_proto_enabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->phy_manager_link_width_enabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->core_to_phy_link_proto_enabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->core_to_phy_link_width_enabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->cable_proto_cap = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 176;
	ptr_struct->link_speed_active = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->link_width_active = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 220;
	ptr_struct->loopback_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 200;
	ptr_struct->retran_mode_request = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->retran_mode_active = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 240;
	ptr_struct->fec_mode_request = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->fec_mode_active = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 284;
	ptr_struct->eth_100g_fec_support = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 280;
	ptr_struct->eth_25g_50g_fec_support = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->profile_fec_in_use = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void DDOperationInfo_print(const struct DDOperationInfo *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DDOperationInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "neg_mode_active      : " UH_FMT "\n", ptr_struct->neg_mode_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "proto_active         : " UH_FMT "\n", ptr_struct->proto_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_phy_fsm_state     : " UH_FMT "\n", ptr_struct->ib_phy_fsm_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_an_fsm_state     : " UH_FMT "\n", ptr_struct->eth_an_fsm_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_mngr_fsm_state   : " UH_FMT "\n", ptr_struct->phy_mngr_fsm_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_manager_link_proto_enabled : " UH_FMT "\n", ptr_struct->phy_manager_link_proto_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_manager_link_width_enabled : " UH_FMT "\n", ptr_struct->phy_manager_link_width_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_to_phy_link_proto_enabled : " UH_FMT "\n", ptr_struct->core_to_phy_link_proto_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_to_phy_link_width_enabled : " UH_FMT "\n", ptr_struct->core_to_phy_link_width_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_proto_cap      : " U32H_FMT "\n", ptr_struct->cable_proto_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_speed_active    : " UH_FMT "\n", ptr_struct->link_speed_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_width_active    : " UH_FMT "\n", ptr_struct->link_width_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "loopback_mode        : " UH_FMT "\n", ptr_struct->loopback_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "retran_mode_request  : " UH_FMT "\n", ptr_struct->retran_mode_request);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "retran_mode_active   : " UH_FMT "\n", ptr_struct->retran_mode_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fec_mode_request     : " UH_FMT "\n", ptr_struct->fec_mode_request);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fec_mode_active      : " UH_FMT "\n", ptr_struct->fec_mode_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_100g_fec_support : " UH_FMT "\n", ptr_struct->eth_100g_fec_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_25g_50g_fec_support : " UH_FMT "\n", ptr_struct->eth_25g_50g_fec_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "profile_fec_in_use   : " UH_FMT "\n", ptr_struct->profile_fec_in_use);

}

int DDOperationInfo_size(void)
{
	return 36;
}

void DDOperationInfo_dump(const struct DDOperationInfo *ptr_struct, FILE *file)
{
	DDOperationInfo_print(ptr_struct, file, 0);
}

void DDPCIPerfCounters_pack(const struct DDPCIPerfCounters *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->life_time_counter_high);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->life_time_counter_low);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rx_errors);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_errors);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->l0_to_recovery_eieos);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->l0_to_recovery_ts);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->l0_to_recovery_framing);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->l0_to_recovery_retrain);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->crc_error_dllp);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->crc_error_tlp);

}

void DDPCIPerfCounters_unpack(struct DDPCIPerfCounters *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->life_time_counter_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->life_time_counter_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->rx_errors = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->tx_errors = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->l0_to_recovery_eieos = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->l0_to_recovery_ts = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->l0_to_recovery_framing = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->l0_to_recovery_retrain = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->crc_error_dllp = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->crc_error_tlp = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void DDPCIPerfCounters_print(const struct DDPCIPerfCounters *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DDPCIPerfCounters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "life_time_counter_high : " U32H_FMT "\n", ptr_struct->life_time_counter_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "life_time_counter_low : " U32H_FMT "\n", ptr_struct->life_time_counter_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_errors            : " U32H_FMT "\n", ptr_struct->rx_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_errors            : " U32H_FMT "\n", ptr_struct->tx_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l0_to_recovery_eieos : " U32H_FMT "\n", ptr_struct->l0_to_recovery_eieos);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l0_to_recovery_ts    : " U32H_FMT "\n", ptr_struct->l0_to_recovery_ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l0_to_recovery_framing : " U32H_FMT "\n", ptr_struct->l0_to_recovery_framing);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l0_to_recovery_retrain : " U32H_FMT "\n", ptr_struct->l0_to_recovery_retrain);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "crc_error_dllp       : " U32H_FMT "\n", ptr_struct->crc_error_dllp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "crc_error_tlp        : " U32H_FMT "\n", ptr_struct->crc_error_tlp);

}

int DDPCIPerfCounters_size(void)
{
	return 40;
}

void DDPCIPerfCounters_dump(const struct DDPCIPerfCounters *ptr_struct, FILE *file)
{
	DDPCIPerfCounters_print(ptr_struct, file, 0);
}

void DDPhyInfo_pack(const struct DDPhyInfo *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port_notifications);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->remote_device_type);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->lp_ib_revision);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ib_revision);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_of_negotiation_attempts);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->phy_manger_disable_mask);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hw_link_phy_state);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->pcs_phy_state);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lp_proto_enabled);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lp_fec_mode_request);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lp_fec_mode_support);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ib_last_link_down_reason);

	offset = 248;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eth_last_link_down_lane_3);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eth_last_link_down_lane_2);

	offset = 232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eth_last_link_down_lane_1);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eth_last_link_down_lane_0);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->speed_deg_db);

	offset = 328;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->degrade_grade_lane_0);

	offset = 360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->degrade_grade_lane_1);

	offset = 392;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->degrade_grade_lane_2);

	offset = 424;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->degrade_grade_lane_3);

	offset = 600;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->kr_startup_fsm_lane_3);

	offset = 592;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->kr_startup_fsm_lane_2);

	offset = 584;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->kr_startup_fsm_lane_1);

	offset = 576;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->kr_startup_fsm_lane_0);

	offset = 640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->eth_an_debug_indication);

	offset = 688;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ib_phy_fsm_state_trace);

	offset = 720;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->kr_startup_debug_indications_1);

	offset = 704;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->kr_startup_debug_indications_0);

	offset = 752;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->kr_startup_debug_indications_3);

	offset = 736;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->kr_startup_debug_indications_2);

	offset = 860;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->irisc_status);

	offset = 864;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->stamping_reason);

}

void DDPhyInfo_unpack(struct DDPhyInfo *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->port_notifications = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->remote_device_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 56;
	ptr_struct->lp_ib_revision = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->ib_revision = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->num_of_negotiation_attempts = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->phy_manger_disable_mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->hw_link_phy_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->pcs_phy_state = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->lp_proto_enabled = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 176;
	ptr_struct->lp_fec_mode_request = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->lp_fec_mode_support = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->ib_last_link_down_reason = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 248;
	ptr_struct->eth_last_link_down_lane_3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 240;
	ptr_struct->eth_last_link_down_lane_2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 232;
	ptr_struct->eth_last_link_down_lane_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 224;
	ptr_struct->eth_last_link_down_lane_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 288;
	ptr_struct->speed_deg_db = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 328;
	ptr_struct->degrade_grade_lane_0 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 360;
	ptr_struct->degrade_grade_lane_1 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 392;
	ptr_struct->degrade_grade_lane_2 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 424;
	ptr_struct->degrade_grade_lane_3 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 600;
	ptr_struct->kr_startup_fsm_lane_3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 592;
	ptr_struct->kr_startup_fsm_lane_2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 584;
	ptr_struct->kr_startup_fsm_lane_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 576;
	ptr_struct->kr_startup_fsm_lane_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 640;
	ptr_struct->eth_an_debug_indication = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 688;
	ptr_struct->ib_phy_fsm_state_trace = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 720;
	ptr_struct->kr_startup_debug_indications_1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 704;
	ptr_struct->kr_startup_debug_indications_0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 752;
	ptr_struct->kr_startup_debug_indications_3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 736;
	ptr_struct->kr_startup_debug_indications_2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 860;
	ptr_struct->irisc_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 864;
	ptr_struct->stamping_reason = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void DDPhyInfo_print(const struct DDPhyInfo *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DDPhyInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_notifications   : " UH_FMT "\n", ptr_struct->port_notifications);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "remote_device_type   : " UH_FMT "\n", ptr_struct->remote_device_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_ib_revision       : " UH_FMT "\n", ptr_struct->lp_ib_revision);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_revision          : " UH_FMT "\n", ptr_struct->ib_revision);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_negotiation_attempts : " UH_FMT "\n", ptr_struct->num_of_negotiation_attempts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_manger_disable_mask : " UH_FMT "\n", ptr_struct->phy_manger_disable_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_link_phy_state    : " UH_FMT "\n", ptr_struct->hw_link_phy_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcs_phy_state        : " U32H_FMT "\n", ptr_struct->pcs_phy_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_proto_enabled     : " U32H_FMT "\n", ptr_struct->lp_proto_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_fec_mode_request  : " UH_FMT "\n", ptr_struct->lp_fec_mode_request);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_fec_mode_support  : " UH_FMT "\n", ptr_struct->lp_fec_mode_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_last_link_down_reason : " U32H_FMT "\n", ptr_struct->ib_last_link_down_reason);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_last_link_down_lane_3 : " UH_FMT "\n", ptr_struct->eth_last_link_down_lane_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_last_link_down_lane_2 : " UH_FMT "\n", ptr_struct->eth_last_link_down_lane_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_last_link_down_lane_1 : " UH_FMT "\n", ptr_struct->eth_last_link_down_lane_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_last_link_down_lane_0 : " UH_FMT "\n", ptr_struct->eth_last_link_down_lane_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "speed_deg_db         : " U32H_FMT "\n", ptr_struct->speed_deg_db);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "degrade_grade_lane_0 : " UH_FMT "\n", ptr_struct->degrade_grade_lane_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "degrade_grade_lane_1 : " UH_FMT "\n", ptr_struct->degrade_grade_lane_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "degrade_grade_lane_2 : " UH_FMT "\n", ptr_struct->degrade_grade_lane_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "degrade_grade_lane_3 : " UH_FMT "\n", ptr_struct->degrade_grade_lane_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_fsm_lane_3 : " UH_FMT "\n", ptr_struct->kr_startup_fsm_lane_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_fsm_lane_2 : " UH_FMT "\n", ptr_struct->kr_startup_fsm_lane_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_fsm_lane_1 : " UH_FMT "\n", ptr_struct->kr_startup_fsm_lane_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_fsm_lane_0 : " UH_FMT "\n", ptr_struct->kr_startup_fsm_lane_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_an_debug_indication : " U32H_FMT "\n", ptr_struct->eth_an_debug_indication);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_phy_fsm_state_trace : " UH_FMT "\n", ptr_struct->ib_phy_fsm_state_trace);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_debug_indications_1 : " UH_FMT "\n", ptr_struct->kr_startup_debug_indications_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_debug_indications_0 : " UH_FMT "\n", ptr_struct->kr_startup_debug_indications_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_debug_indications_3 : " UH_FMT "\n", ptr_struct->kr_startup_debug_indications_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_debug_indications_2 : " UH_FMT "\n", ptr_struct->kr_startup_debug_indications_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "irisc_status         : " UH_FMT "\n", ptr_struct->irisc_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "stamping_reason      : " U32H_FMT "\n", ptr_struct->stamping_reason);

}

int DDPhyInfo_size(void)
{
	return 112;
}

void DDPhyInfo_dump(const struct DDPhyInfo *ptr_struct, FILE *file)
{
	DDPhyInfo_print(ptr_struct, file, 0);
}

void DDPhysCounters_pack(const struct DDPhysCounters *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 24; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 1600, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->counter[i]);
	}

	offset = 1536;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->counter24);

	offset = 1568;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->counter25);

}

void DDPhysCounters_unpack(struct DDPhysCounters *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 24; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 1600, 1);
	ptr_struct->counter[i] = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);
	}

	offset = 1536;
	ptr_struct->counter24 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1568;
	ptr_struct->counter25 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void DDPhysCounters_print(const struct DDPhysCounters *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DDPhysCounters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 24; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_%03d         : " U64H_FMT "\n", i, ptr_struct->counter[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter24            : " U32H_FMT "\n", ptr_struct->counter24);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter25            : " U32H_FMT "\n", ptr_struct->counter25);

}

int DDPhysCounters_size(void)
{
	return 200;
}

void DDPhysCounters_dump(const struct DDPhysCounters *ptr_struct, FILE *file)
{
	DDPhysCounters_print(ptr_struct, file, 0);
}

void DDTroubleShootingInfo_pack(const struct DDTroubleShootingInfo *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->group_opcode);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->status_opcode);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->user_feedback_index);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->user_feedback_data);

	for (i = 0; i < 204; i++) {
	offset = adb2c_calc_array_field_address(120, 8, i, 1728, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->status_message[i]);
	}

}

void DDTroubleShootingInfo_unpack(struct DDTroubleShootingInfo *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->group_opcode = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->status_opcode = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 80;
	ptr_struct->user_feedback_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->user_feedback_data = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i = 0; i < 204; i++) {
	offset = adb2c_calc_array_field_address(120, 8, i, 1728, 1);
	ptr_struct->status_message[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->status_message[204] = '\0';
}

void DDTroubleShootingInfo_print(const struct DDTroubleShootingInfo *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DDTroubleShootingInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_opcode         : " UH_FMT "\n", ptr_struct->group_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status_opcode        : " U32H_FMT "\n", ptr_struct->status_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "user_feedback_index  : " UH_FMT "\n", ptr_struct->user_feedback_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "user_feedback_data   : " UH_FMT "\n", ptr_struct->user_feedback_data);

	fprintf(file, "status_message       : \"%s\"\n", ptr_struct->status_message);
}

int DDTroubleShootingInfo_size(void)
{
	return 216;
}

void DDTroubleShootingInfo_dump(const struct DDTroubleShootingInfo *ptr_struct, FILE *file)
{
	DDTroubleShootingInfo_print(ptr_struct, file, 0);
}

void DD_PLR_Counters_pack(const struct DD_PLR_Counters *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->plr_rcv_codes);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->plr_rcv_code_err);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->plr_rcv_uncorrectable_code);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->plr_xmit_codes);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->plr_xmit_retry_codes);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->plr_xmit_retry_events);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->plr_sync_events);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->hi_retransmission_rate);

}

void DD_PLR_Counters_unpack(struct DD_PLR_Counters *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->plr_rcv_codes = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->plr_rcv_code_err = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->plr_rcv_uncorrectable_code = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->plr_xmit_codes = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 256;
	ptr_struct->plr_xmit_retry_codes = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 320;
	ptr_struct->plr_xmit_retry_events = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 384;
	ptr_struct->plr_sync_events = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 448;
	ptr_struct->hi_retransmission_rate = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void DD_PLR_Counters_print(const struct DD_PLR_Counters *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DD_PLR_Counters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_rcv_codes        : " U64H_FMT "\n", ptr_struct->plr_rcv_codes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_rcv_code_err     : " U64H_FMT "\n", ptr_struct->plr_rcv_code_err);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_rcv_uncorrectable_code : " U64H_FMT "\n", ptr_struct->plr_rcv_uncorrectable_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_xmit_codes       : " U64H_FMT "\n", ptr_struct->plr_xmit_codes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_xmit_retry_codes : " U64H_FMT "\n", ptr_struct->plr_xmit_retry_codes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_xmit_retry_events : " U64H_FMT "\n", ptr_struct->plr_xmit_retry_events);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_sync_events      : " U64H_FMT "\n", ptr_struct->plr_sync_events);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hi_retransmission_rate : " U64H_FMT "\n", ptr_struct->hi_retransmission_rate);

}

int DD_PLR_Counters_size(void)
{
	return 64;
}

void DD_PLR_Counters_dump(const struct DD_PLR_Counters *ptr_struct, FILE *file)
{
	DD_PLR_Counters_print(ptr_struct, file, 0);
}

void DD_PhyStatisticalCounters_pack(const struct DD_PhyStatisticalCounters *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->time_since_last_clear);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_received_bits);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_symbol_errors);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_corrected_bits);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_raw_errors_lane0);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_raw_errors_lane1);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_raw_errors_lane2);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_raw_errors_lane3);

	offset = 796;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->raw_ber_coef);

	offset = 784;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->raw_ber_magnitude);

	offset = 828;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->effective_ber_coef);

	offset = 816;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->effective_ber_magnitude);

}

void DD_PhyStatisticalCounters_unpack(struct DD_PhyStatisticalCounters *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->time_since_last_clear = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->phy_received_bits = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->phy_symbol_errors = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->phy_corrected_bits = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 256;
	ptr_struct->phy_raw_errors_lane0 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 320;
	ptr_struct->phy_raw_errors_lane1 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 384;
	ptr_struct->phy_raw_errors_lane2 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 448;
	ptr_struct->phy_raw_errors_lane3 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 796;
	ptr_struct->raw_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 784;
	ptr_struct->raw_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 828;
	ptr_struct->effective_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 816;
	ptr_struct->effective_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void DD_PhyStatisticalCounters_print(const struct DD_PhyStatisticalCounters *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DD_PhyStatisticalCounters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_since_last_clear : " U64H_FMT "\n", ptr_struct->time_since_last_clear);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_received_bits    : " U64H_FMT "\n", ptr_struct->phy_received_bits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_symbol_errors    : " U64H_FMT "\n", ptr_struct->phy_symbol_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_corrected_bits   : " U64H_FMT "\n", ptr_struct->phy_corrected_bits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_raw_errors_lane0 : " U64H_FMT "\n", ptr_struct->phy_raw_errors_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_raw_errors_lane1 : " U64H_FMT "\n", ptr_struct->phy_raw_errors_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_raw_errors_lane2 : " U64H_FMT "\n", ptr_struct->phy_raw_errors_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_raw_errors_lane3 : " U64H_FMT "\n", ptr_struct->phy_raw_errors_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_coef         : " UH_FMT "\n", ptr_struct->raw_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_magnitude    : " UH_FMT "\n", ptr_struct->raw_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "effective_ber_coef   : " UH_FMT "\n", ptr_struct->effective_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "effective_ber_magnitude : " UH_FMT "\n", ptr_struct->effective_ber_magnitude);

}

int DD_PhyStatisticalCounters_size(void)
{
	return 104;
}

void DD_PhyStatisticalCounters_dump(const struct DD_PhyStatisticalCounters *ptr_struct, FILE *file)
{
	DD_PhyStatisticalCounters_print(ptr_struct, file, 0);
}

void DD_RS_Histograms_pack(const struct DD_RS_Histograms *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 1024, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->hist[i]);
	}

}

void DD_RS_Histograms_unpack(struct DD_RS_Histograms *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 1024, 1);
	ptr_struct->hist[i] = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);
	}

}

void DD_RS_Histograms_print(const struct DD_RS_Histograms *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DD_RS_Histograms ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hist_%03d            : " U64H_FMT "\n", i, ptr_struct->hist[i]);
	}

}

int DD_RS_Histograms_size(void)
{
	return 128;
}

void DD_RS_Histograms_dump(const struct DD_RS_Histograms *ptr_struct, FILE *file)
{
	DD_RS_Histograms_print(ptr_struct, file, 0);
}

void DD_ZL_FEC_Counters_pack(const struct DD_ZL_FEC_Counters *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->rewind_counter);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->data_rewined);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->pkt_rewined);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->total_rcv_data);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->total_rcv_pkt);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->stay_in_slow);

}

void DD_ZL_FEC_Counters_unpack(struct DD_ZL_FEC_Counters *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->rewind_counter = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->data_rewined = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->pkt_rewined = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->total_rcv_data = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 256;
	ptr_struct->total_rcv_pkt = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 320;
	ptr_struct->stay_in_slow = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void DD_ZL_FEC_Counters_print(const struct DD_ZL_FEC_Counters *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DD_ZL_FEC_Counters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rewind_counter       : " U64H_FMT "\n", ptr_struct->rewind_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_rewined         : " U64H_FMT "\n", ptr_struct->data_rewined);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkt_rewined          : " U64H_FMT "\n", ptr_struct->pkt_rewined);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "total_rcv_data       : " U64H_FMT "\n", ptr_struct->total_rcv_data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "total_rcv_pkt        : " U64H_FMT "\n", ptr_struct->total_rcv_pkt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "stay_in_slow         : " U64H_FMT "\n", ptr_struct->stay_in_slow);

}

int DD_ZL_FEC_Counters_size(void)
{
	return 48;
}

void DD_ZL_FEC_Counters_dump(const struct DD_ZL_FEC_Counters *ptr_struct, FILE *file)
{
	DD_ZL_FEC_Counters_print(ptr_struct, file, 0);
}

void SMP_ARGroupTable_pack(const struct SMP_ARGroupTable *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(0, 256, i, 512, 1);
	PortGroup_Block_Element_pack(&(ptr_struct->Group[i]), ptr_buff + offset/8);
	}

}

void SMP_ARGroupTable_unpack(struct SMP_ARGroupTable *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(0, 256, i, 512, 1);
	PortGroup_Block_Element_unpack(&(ptr_struct->Group[i]), ptr_buff + offset/8);
	}

}

void SMP_ARGroupTable_print(const struct SMP_ARGroupTable *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_ARGroupTable ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Group_%03d:\n", i);
	PortGroup_Block_Element_print(&(ptr_struct->Group[i]), file, indent_level + 1);
	}

}

int SMP_ARGroupTable_size(void)
{
	return 64;
}

void SMP_ARGroupTable_dump(const struct SMP_ARGroupTable *ptr_struct, FILE *file)
{
	SMP_ARGroupTable_print(ptr_struct, file, 0);
}

void SMP_ARLinearForwardingTable_pack(const struct SMP_ARLinearForwardingTable *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 512, 1);
	LidPortMapping_Block_Element_pack(&(ptr_struct->LidEntry[i]), ptr_buff + offset/8);
	}

}

void SMP_ARLinearForwardingTable_unpack(struct SMP_ARLinearForwardingTable *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 32; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 512, 1);
	LidPortMapping_Block_Element_unpack(&(ptr_struct->LidEntry[i]), ptr_buff + offset/8);
	}

}

void SMP_ARLinearForwardingTable_print(const struct SMP_ARLinearForwardingTable *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_ARLinearForwardingTable ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LidEntry_%03d:\n", i);
	LidPortMapping_Block_Element_print(&(ptr_struct->LidEntry[i]), file, indent_level + 1);
	}

}

int SMP_ARLinearForwardingTable_size(void)
{
	return 64;
}

void SMP_ARLinearForwardingTable_dump(const struct SMP_ARLinearForwardingTable *ptr_struct, FILE *file)
{
	SMP_ARLinearForwardingTable_print(ptr_struct, file, 0);
}

void SMP_ARLinearForwardingTable_SX_pack(const struct SMP_ARLinearForwardingTable_SX *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	LidPortMapping_Block_Element_SX_pack(&(ptr_struct->LidEntry[i]), ptr_buff + offset/8);
	}

}

void SMP_ARLinearForwardingTable_SX_unpack(struct SMP_ARLinearForwardingTable_SX *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	LidPortMapping_Block_Element_SX_unpack(&(ptr_struct->LidEntry[i]), ptr_buff + offset/8);
	}

}

void SMP_ARLinearForwardingTable_SX_print(const struct SMP_ARLinearForwardingTable_SX *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_ARLinearForwardingTable_SX ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LidEntry_%03d:\n", i);
	LidPortMapping_Block_Element_SX_print(&(ptr_struct->LidEntry[i]), file, indent_level + 1);
	}

}

int SMP_ARLinearForwardingTable_SX_size(void)
{
	return 64;
}

void SMP_ARLinearForwardingTable_SX_dump(const struct SMP_ARLinearForwardingTable_SX *ptr_struct, FILE *file)
{
	SMP_ARLinearForwardingTable_SX_print(ptr_struct, file, 0);
}

void SMP_CableInfo_pack(const struct SMP_CableInfo *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->address);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->page_number);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->device_address);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->size);

	offset = 33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pw_clr);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pw_v);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->password);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Reserved1);

	for (i = 0; i < 48; i++) {
	offset = adb2c_calc_array_field_address(152, 8, i, 512, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Byte[i]);
	}

}

void SMP_CableInfo_unpack(struct SMP_CableInfo *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->address = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 8;
	ptr_struct->page_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->device_address = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 33;
	ptr_struct->pw_clr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->pw_v = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 64;
	ptr_struct->password = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->Reserved1 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	for (i = 0; i < 48; i++) {
	offset = adb2c_calc_array_field_address(152, 8, i, 512, 1);
	ptr_struct->Byte[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void SMP_CableInfo_print(const struct SMP_CableInfo *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_CableInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "address              : " UH_FMT "\n", ptr_struct->address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_number          : " UH_FMT "\n", ptr_struct->page_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_address       : " UH_FMT "\n", ptr_struct->device_address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "size                 : " UH_FMT "\n", ptr_struct->size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pw_clr               : " UH_FMT "\n", ptr_struct->pw_clr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pw_v                 : " UH_FMT "\n", ptr_struct->pw_v);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "password             : " U32H_FMT "\n", ptr_struct->password);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved1            : " U32H_FMT "\n", ptr_struct->Reserved1);

	for (i = 0; i < 48; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Byte_%03d            : " UH_FMT "\n", i, ptr_struct->Byte[i]);
	}

}

int SMP_CableInfo_size(void)
{
	return 64;
}

void SMP_CableInfo_dump(const struct SMP_CableInfo *ptr_struct, FILE *file)
{
	SMP_CableInfo_print(ptr_struct, file, 0);
}

void SMP_EyeOpen_pack(const struct SMP_EyeOpen *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LinkWidthActive);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Reserved1);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->AutoNegoState);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->Reserved0);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->HighAmplitude_Lane0);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LowAmplitude_Lane0);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PositiveBound_Lane0);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->NegativeBound_Lane0);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SelectedOptionTX_Lane0);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SelectedOptionRX_Lane0);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AmpCalibration_Lane0);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->HighAmplitude_Lane1);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LowAmplitude_Lane1);

	offset = 184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PositiveBound_Lane1);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->NegativeBound_Lane1);

	offset = 216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SelectedOptionTX_Lane1);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SelectedOptionRX_Lane1);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AmpCalibration_Lane1);

	offset = 248;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->HighAmplitude_Lane2);

	offset = 232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LowAmplitude_Lane2);

	offset = 280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PositiveBound_Lane2);

	offset = 264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->NegativeBound_Lane2);

	offset = 312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SelectedOptionTX_Lane2);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SelectedOptionRX_Lane2);

	offset = 296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AmpCalibration_Lane2);

	offset = 344;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->HighAmplitude_Lane3);

	offset = 328;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LowAmplitude_Lane3);

	offset = 376;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PositiveBound_Lane3);

	offset = 360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->NegativeBound_Lane3);

	offset = 408;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SelectedOptionTX_Lane3);

	offset = 400;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SelectedOptionRX_Lane3);

	offset = 392;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AmpCalibration_Lane3);

}

void SMP_EyeOpen_unpack(struct SMP_EyeOpen *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->LinkWidthActive = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->Reserved1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 12;
	ptr_struct->AutoNegoState = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->Reserved0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 56;
	ptr_struct->HighAmplitude_Lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->LowAmplitude_Lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->PositiveBound_Lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->NegativeBound_Lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 120;
	ptr_struct->SelectedOptionTX_Lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->SelectedOptionRX_Lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->AmpCalibration_Lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 152;
	ptr_struct->HighAmplitude_Lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 136;
	ptr_struct->LowAmplitude_Lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 184;
	ptr_struct->PositiveBound_Lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 168;
	ptr_struct->NegativeBound_Lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 216;
	ptr_struct->SelectedOptionTX_Lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 208;
	ptr_struct->SelectedOptionRX_Lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 200;
	ptr_struct->AmpCalibration_Lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 248;
	ptr_struct->HighAmplitude_Lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 232;
	ptr_struct->LowAmplitude_Lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 280;
	ptr_struct->PositiveBound_Lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 264;
	ptr_struct->NegativeBound_Lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 312;
	ptr_struct->SelectedOptionTX_Lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 304;
	ptr_struct->SelectedOptionRX_Lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 296;
	ptr_struct->AmpCalibration_Lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 344;
	ptr_struct->HighAmplitude_Lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 328;
	ptr_struct->LowAmplitude_Lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 376;
	ptr_struct->PositiveBound_Lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 360;
	ptr_struct->NegativeBound_Lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 408;
	ptr_struct->SelectedOptionTX_Lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 400;
	ptr_struct->SelectedOptionRX_Lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 392;
	ptr_struct->AmpCalibration_Lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void SMP_EyeOpen_print(const struct SMP_EyeOpen *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_EyeOpen ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkWidthActive      : " UH_FMT "\n", ptr_struct->LinkWidthActive);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved1            : " UH_FMT "\n", ptr_struct->Reserved1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AutoNegoState        : " UH_FMT "\n", ptr_struct->AutoNegoState);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved0            : " UH_FMT "\n", ptr_struct->Reserved0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HighAmplitude_Lane0  : " UH_FMT "\n", ptr_struct->HighAmplitude_Lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LowAmplitude_Lane0   : " UH_FMT "\n", ptr_struct->LowAmplitude_Lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PositiveBound_Lane0  : " UH_FMT "\n", ptr_struct->PositiveBound_Lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NegativeBound_Lane0  : " UH_FMT "\n", ptr_struct->NegativeBound_Lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SelectedOptionTX_Lane0 : " UH_FMT "\n", ptr_struct->SelectedOptionTX_Lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SelectedOptionRX_Lane0 : " UH_FMT "\n", ptr_struct->SelectedOptionRX_Lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AmpCalibration_Lane0 : " UH_FMT "\n", ptr_struct->AmpCalibration_Lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HighAmplitude_Lane1  : " UH_FMT "\n", ptr_struct->HighAmplitude_Lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LowAmplitude_Lane1   : " UH_FMT "\n", ptr_struct->LowAmplitude_Lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PositiveBound_Lane1  : " UH_FMT "\n", ptr_struct->PositiveBound_Lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NegativeBound_Lane1  : " UH_FMT "\n", ptr_struct->NegativeBound_Lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SelectedOptionTX_Lane1 : " UH_FMT "\n", ptr_struct->SelectedOptionTX_Lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SelectedOptionRX_Lane1 : " UH_FMT "\n", ptr_struct->SelectedOptionRX_Lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AmpCalibration_Lane1 : " UH_FMT "\n", ptr_struct->AmpCalibration_Lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HighAmplitude_Lane2  : " UH_FMT "\n", ptr_struct->HighAmplitude_Lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LowAmplitude_Lane2   : " UH_FMT "\n", ptr_struct->LowAmplitude_Lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PositiveBound_Lane2  : " UH_FMT "\n", ptr_struct->PositiveBound_Lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NegativeBound_Lane2  : " UH_FMT "\n", ptr_struct->NegativeBound_Lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SelectedOptionTX_Lane2 : " UH_FMT "\n", ptr_struct->SelectedOptionTX_Lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SelectedOptionRX_Lane2 : " UH_FMT "\n", ptr_struct->SelectedOptionRX_Lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AmpCalibration_Lane2 : " UH_FMT "\n", ptr_struct->AmpCalibration_Lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HighAmplitude_Lane3  : " UH_FMT "\n", ptr_struct->HighAmplitude_Lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LowAmplitude_Lane3   : " UH_FMT "\n", ptr_struct->LowAmplitude_Lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PositiveBound_Lane3  : " UH_FMT "\n", ptr_struct->PositiveBound_Lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NegativeBound_Lane3  : " UH_FMT "\n", ptr_struct->NegativeBound_Lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SelectedOptionTX_Lane3 : " UH_FMT "\n", ptr_struct->SelectedOptionTX_Lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SelectedOptionRX_Lane3 : " UH_FMT "\n", ptr_struct->SelectedOptionRX_Lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AmpCalibration_Lane3 : " UH_FMT "\n", ptr_struct->AmpCalibration_Lane3);

}

int SMP_EyeOpen_size(void)
{
	return 64;
}

void SMP_EyeOpen_dump(const struct SMP_EyeOpen *ptr_struct, FILE *file)
{
	SMP_EyeOpen_print(ptr_struct, file, 0);
}

void SMP_LossyLinkConfig_pack(const struct SMP_LossyLinkConfig *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Ignore_Credits_Mask);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Ignore_Buffer_Overrun_Mask);

}

void SMP_LossyLinkConfig_unpack(struct SMP_LossyLinkConfig *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->Ignore_Credits_Mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->Ignore_Buffer_Overrun_Mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void SMP_LossyLinkConfig_print(const struct SMP_LossyLinkConfig *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_LossyLinkConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Ignore_Credits_Mask  : " UH_FMT "\n", ptr_struct->Ignore_Credits_Mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Ignore_Buffer_Overrun_Mask : " UH_FMT "\n", ptr_struct->Ignore_Buffer_Overrun_Mask);

}

int SMP_LossyLinkConfig_size(void)
{
	return 4;
}

void SMP_LossyLinkConfig_dump(const struct SMP_LossyLinkConfig *ptr_struct, FILE *file)
{
	SMP_LossyLinkConfig_print(ptr_struct, file, 0);
}

void SMP_MAD_AttrMod_CableInfo_pack(const struct SMP_MAD_AttrMod_CableInfo *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortSelect);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->Reserved);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->BitLock);

}

void SMP_MAD_AttrMod_CableInfo_unpack(struct SMP_MAD_AttrMod_CableInfo *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->PortSelect = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1;
	ptr_struct->Reserved = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset = 0;
	ptr_struct->BitLock = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void SMP_MAD_AttrMod_CableInfo_print(const struct SMP_MAD_AttrMod_CableInfo *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_MAD_AttrMod_CableInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSelect           : " UH_FMT "\n", ptr_struct->PortSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved             : " UH_FMT "\n", ptr_struct->Reserved);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "BitLock              : " UH_FMT "\n", ptr_struct->BitLock);

}

int SMP_MAD_AttrMod_CableInfo_size(void)
{
	return 4;
}

void SMP_MAD_AttrMod_CableInfo_dump(const struct SMP_MAD_AttrMod_CableInfo *ptr_struct, FILE *file)
{
	SMP_MAD_AttrMod_CableInfo_print(ptr_struct, file, 0);
}

void SMP_MAD_AttrMod_EyeOpen_pack(const struct SMP_MAD_AttrMod_EyeOpen *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortSelect);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->GroupLane);

}

void SMP_MAD_AttrMod_EyeOpen_unpack(struct SMP_MAD_AttrMod_EyeOpen *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->PortSelect = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->GroupLane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void SMP_MAD_AttrMod_EyeOpen_print(const struct SMP_MAD_AttrMod_EyeOpen *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_MAD_AttrMod_EyeOpen ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSelect           : " UH_FMT "\n", ptr_struct->PortSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "GroupLane            : " UH_FMT "\n", ptr_struct->GroupLane);

}

int SMP_MAD_AttrMod_EyeOpen_size(void)
{
	return 4;
}

void SMP_MAD_AttrMod_EyeOpen_dump(const struct SMP_MAD_AttrMod_EyeOpen *ptr_struct, FILE *file)
{
	SMP_MAD_AttrMod_EyeOpen_print(ptr_struct, file, 0);
}

void SMP_PortSLToPrivateLFTMap_pack(const struct SMP_PortSLToPrivateLFTMap *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(0, 128, i, 512, 1);
	PortSLToPLFT_pack(&(ptr_struct->PortSLToPLFT[i]), ptr_buff + offset/8);
	}

}

void SMP_PortSLToPrivateLFTMap_unpack(struct SMP_PortSLToPrivateLFTMap *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(0, 128, i, 512, 1);
	PortSLToPLFT_unpack(&(ptr_struct->PortSLToPLFT[i]), ptr_buff + offset/8);
	}

}

void SMP_PortSLToPrivateLFTMap_print(const struct SMP_PortSLToPrivateLFTMap *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_PortSLToPrivateLFTMap ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSLToPLFT_%03d:\n", i);
	PortSLToPLFT_print(&(ptr_struct->PortSLToPLFT[i]), file, indent_level + 1);
	}

}

int SMP_PortSLToPrivateLFTMap_size(void)
{
	return 64;
}

void SMP_PortSLToPrivateLFTMap_dump(const struct SMP_PortSLToPrivateLFTMap *ptr_struct, FILE *file)
{
	SMP_PortSLToPrivateLFTMap_print(ptr_struct, file, 0);
}

void SMP_PrivateLFT_pack(const struct SMP_PrivateLFT *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 12; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 384, 1);
	PLFT_Entry_Block_Element_pack(&(ptr_struct->Entry[i]), ptr_buff + offset/8);
	}

}

void SMP_PrivateLFT_unpack(struct SMP_PrivateLFT *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 12; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 384, 1);
	PLFT_Entry_Block_Element_unpack(&(ptr_struct->Entry[i]), ptr_buff + offset/8);
	}

}

void SMP_PrivateLFT_print(const struct SMP_PrivateLFT *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_PrivateLFT ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 12; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Entry_%03d:\n", i);
	PLFT_Entry_Block_Element_print(&(ptr_struct->Entry[i]), file, indent_level + 1);
	}

}

int SMP_PrivateLFT_size(void)
{
	return 48;
}

void SMP_PrivateLFT_dump(const struct SMP_PrivateLFT *ptr_struct, FILE *file)
{
	SMP_PrivateLFT_print(ptr_struct, file, 0);
}

void SMP_PrivateLFTDef_pack(const struct SMP_PrivateLFTDef *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	LFT_Priv_Block_Element_pack(&(ptr_struct->LFT[i]), ptr_buff + offset/8);
	}

}

void SMP_PrivateLFTDef_unpack(struct SMP_PrivateLFTDef *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 512, 1);
	LFT_Priv_Block_Element_unpack(&(ptr_struct->LFT[i]), ptr_buff + offset/8);
	}

}

void SMP_PrivateLFTDef_print(const struct SMP_PrivateLFTDef *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_PrivateLFTDef ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LFT_%03d:\n", i);
	LFT_Priv_Block_Element_print(&(ptr_struct->LFT[i]), file, indent_level + 1);
	}

}

int SMP_PrivateLFTDef_size(void)
{
	return 64;
}

void SMP_PrivateLFTDef_dump(const struct SMP_PrivateLFTDef *ptr_struct, FILE *file)
{
	SMP_PrivateLFTDef_print(ptr_struct, file, 0);
}

void SMP_PrivateLFTInfo_pack(const struct SMP_PrivateLFTInfo *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->Active_Mode);

	offset = 21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->ModeCap);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->NumPLFTs);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->NoFallback);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(48, 16, i, 512, 1);
	Description_Mode_Block_Element_pack(&(ptr_struct->Description_Mode[i]), ptr_buff + offset/8);
	}

}

void SMP_PrivateLFTInfo_unpack(struct SMP_PrivateLFTInfo *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	ptr_struct->Active_Mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 21;
	ptr_struct->ModeCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 8;
	ptr_struct->NumPLFTs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 7;
	ptr_struct->NoFallback = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(48, 16, i, 512, 1);
	Description_Mode_Block_Element_unpack(&(ptr_struct->Description_Mode[i]), ptr_buff + offset/8);
	}

}

void SMP_PrivateLFTInfo_print(const struct SMP_PrivateLFTInfo *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_PrivateLFTInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Active_Mode          : " UH_FMT "\n", ptr_struct->Active_Mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ModeCap              : " UH_FMT "\n", ptr_struct->ModeCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NumPLFTs             : " UH_FMT "\n", ptr_struct->NumPLFTs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NoFallback           : " UH_FMT "\n", ptr_struct->NoFallback);

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Description_Mode_%03d:\n", i);
	Description_Mode_Block_Element_print(&(ptr_struct->Description_Mode[i]), file, indent_level + 1);
	}

}

int SMP_PrivateLFTInfo_size(void)
{
	return 64;
}

void SMP_PrivateLFTInfo_dump(const struct SMP_PrivateLFTInfo *ptr_struct, FILE *file)
{
	SMP_PrivateLFTInfo_print(ptr_struct, file, 0);
}

void SMP_PrivateLFTMap_pack(const struct SMP_PrivateLFTMap *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->Port_MaskEn);

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->LFT_TopEn);

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(32, 32, i, 320, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->FDB_Port_Group_Mask[i]);
	}

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->LFT_Top);

}

void SMP_PrivateLFTMap_unpack(struct SMP_PrivateLFTMap *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->Port_MaskEn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 30;
	ptr_struct->LFT_TopEn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(32, 32, i, 320, 1);
	ptr_struct->FDB_Port_Group_Mask[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset = 304;
	ptr_struct->LFT_Top = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void SMP_PrivateLFTMap_print(const struct SMP_PrivateLFTMap *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_PrivateLFTMap ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Port_MaskEn          : " UH_FMT "\n", ptr_struct->Port_MaskEn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LFT_TopEn            : " UH_FMT "\n", ptr_struct->LFT_TopEn);

	for (i = 0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FDB_Port_Group_Mask_%03d : " U32H_FMT "\n", i, ptr_struct->FDB_Port_Group_Mask[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LFT_Top              : " UH_FMT "\n", ptr_struct->LFT_Top);

}

int SMP_PrivateLFTMap_size(void)
{
	return 40;
}

void SMP_PrivateLFTMap_dump(const struct SMP_PrivateLFTMap *ptr_struct, FILE *file)
{
	SMP_PrivateLFTMap_print(ptr_struct, file, 0);
}

void SMP_TemperatureSensing_pack(const struct SMP_TemperatureSensing *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tss);

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->stgs);

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->stge);

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wtts);

	offset = 27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wtte);

	offset = 26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wtgs);

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wtge);

	offset = 53;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->current_temp);

	offset = 37;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->max_temp);

	offset = 85;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->overtemp_warning_threshold_hi);

	offset = 69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->overtemp_warning_threshold_lo);

	offset = 127;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ws);

	offset = 126;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wga);

	offset = 125;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wgp);

	offset = 123;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->wgm);

}

void SMP_TemperatureSensing_unpack(struct SMP_TemperatureSensing *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->tss = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 30;
	ptr_struct->stgs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 29;
	ptr_struct->stge = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 28;
	ptr_struct->wtts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 27;
	ptr_struct->wtte = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 26;
	ptr_struct->wtgs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 25;
	ptr_struct->wtge = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 53;
	ptr_struct->current_temp = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 37;
	ptr_struct->max_temp = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 85;
	ptr_struct->overtemp_warning_threshold_hi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 69;
	ptr_struct->overtemp_warning_threshold_lo = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 127;
	ptr_struct->ws = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 126;
	ptr_struct->wga = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 125;
	ptr_struct->wgp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 123;
	ptr_struct->wgm = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void SMP_TemperatureSensing_print(const struct SMP_TemperatureSensing *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_TemperatureSensing ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tss                  : " UH_FMT "\n", ptr_struct->tss);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "stgs                 : " UH_FMT "\n", ptr_struct->stgs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "stge                 : " UH_FMT "\n", ptr_struct->stge);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wtts                 : " UH_FMT "\n", ptr_struct->wtts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wtte                 : " UH_FMT "\n", ptr_struct->wtte);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wtgs                 : " UH_FMT "\n", ptr_struct->wtgs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wtge                 : " UH_FMT "\n", ptr_struct->wtge);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "current_temp         : " UH_FMT "\n", ptr_struct->current_temp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_temp             : " UH_FMT "\n", ptr_struct->max_temp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "overtemp_warning_threshold_hi : " UH_FMT "\n", ptr_struct->overtemp_warning_threshold_hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "overtemp_warning_threshold_lo : " UH_FMT "\n", ptr_struct->overtemp_warning_threshold_lo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ws                   : " UH_FMT "\n", ptr_struct->ws);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wga                  : " UH_FMT "\n", ptr_struct->wga);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wgp                  : " UH_FMT "\n", ptr_struct->wgp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wgm                  : " UH_FMT "\n", ptr_struct->wgm);

}

int SMP_TemperatureSensing_size(void)
{
	return 16;
}

void SMP_TemperatureSensing_dump(const struct SMP_TemperatureSensing *ptr_struct, FILE *file)
{
	SMP_TemperatureSensing_print(ptr_struct, file, 0);
}

void VendorSpec_PhyConfig_pack(const struct VendorSpec_PhyConfig *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortMode);

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->MasterPort);

	offset = 23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->Sloop);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SerDesParamsLinkSpeeds);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortCommand);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->TxPolarity);

	offset = 46;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->TxReserveLane);

	offset = 45;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->TXReverseSub0);

	offset = 43;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->TXReverseSub1);

	offset = 41;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->TXReverseSub2);

	offset = 39;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ClusterEnable);

	offset = 84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->SerDesParameterLanesEnable);

}

void VendorSpec_PhyConfig_unpack(struct VendorSpec_PhyConfig *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	ptr_struct->PortMode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 24;
	ptr_struct->MasterPort = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 23;
	ptr_struct->Sloop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 16;
	ptr_struct->SerDesParamsLinkSpeeds = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 8;
	ptr_struct->PortCommand = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 52;
	ptr_struct->TxPolarity = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 46;
	ptr_struct->TxReserveLane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 45;
	ptr_struct->TXReverseSub0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 43;
	ptr_struct->TXReverseSub1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 41;
	ptr_struct->TXReverseSub2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 39;
	ptr_struct->ClusterEnable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 84;
	ptr_struct->SerDesParameterLanesEnable = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

}

void VendorSpec_PhyConfig_print(const struct VendorSpec_PhyConfig *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VendorSpec_PhyConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortMode             : " UH_FMT "\n", ptr_struct->PortMode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MasterPort           : " UH_FMT "\n", ptr_struct->MasterPort);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Sloop                : " UH_FMT "\n", ptr_struct->Sloop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SerDesParamsLinkSpeeds : " UH_FMT "\n", ptr_struct->SerDesParamsLinkSpeeds);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortCommand          : " UH_FMT "\n", ptr_struct->PortCommand);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TxPolarity           : " UH_FMT "\n", ptr_struct->TxPolarity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TxReserveLane        : " UH_FMT "\n", ptr_struct->TxReserveLane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXReverseSub0        : " UH_FMT "\n", ptr_struct->TXReverseSub0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXReverseSub1        : " UH_FMT "\n", ptr_struct->TXReverseSub1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXReverseSub2        : " UH_FMT "\n", ptr_struct->TXReverseSub2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ClusterEnable        : " UH_FMT "\n", ptr_struct->ClusterEnable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SerDesParameterLanesEnable : " UH_FMT "\n", ptr_struct->SerDesParameterLanesEnable);

}

int VendorSpec_PhyConfig_size(void)
{
	return 156;
}

void VendorSpec_PhyConfig_dump(const struct VendorSpec_PhyConfig *ptr_struct, FILE *file)
{
	VendorSpec_PhyConfig_print(ptr_struct, file, 0);
}

void fore_reg_pack(const struct fore_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fan_under_limit);

	offset = 38;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fan_over_limit);

}

void fore_reg_unpack(struct fore_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 6;
	ptr_struct->fan_under_limit = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 38;
	ptr_struct->fan_over_limit = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

}

void fore_reg_print(const struct fore_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== fore_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fan_under_limit      : " UH_FMT "\n", ptr_struct->fan_under_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fan_over_limit       : " UH_FMT "\n", ptr_struct->fan_over_limit);

}

int fore_reg_size(void)
{
	return 12;
}

void fore_reg_dump(const struct fore_reg *ptr_struct, FILE *file)
{
	fore_reg_print(ptr_struct, file, 0);
}

void mfcr_reg_pack(const struct mfcr_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 38;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->tacho_active);

}

void mfcr_reg_unpack(struct mfcr_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 38;
	ptr_struct->tacho_active = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

}

void mfcr_reg_print(const struct mfcr_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mfcr_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tacho_active         : " UH_FMT "\n", ptr_struct->tacho_active);

}

int mfcr_reg_size(void)
{
	return 8;
}

void mfcr_reg_dump(const struct mfcr_reg *ptr_struct, FILE *file)
{
	mfcr_reg_print(ptr_struct, file, 0);
}

void mfnr_reg_pack(const struct mfnr_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->fan_index);

	for (i = 0; i < 24; i++) {
	offset = adb2c_calc_array_field_address(56, 8, i, 352, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->serial_number[i]);
	}

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(248, 8, i, 352, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->part_number[i]);
	}

}

void mfnr_reg_unpack(struct mfnr_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 27;
	ptr_struct->fan_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	for (i = 0; i < 24; i++) {
	offset = adb2c_calc_array_field_address(56, 8, i, 352, 1);
	ptr_struct->serial_number[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->serial_number[24] = '\0';
	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(248, 8, i, 352, 1);
	ptr_struct->part_number[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->part_number[16] = '\0';
}

void mfnr_reg_print(const struct mfnr_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mfnr_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fan_index            : " UH_FMT "\n", ptr_struct->fan_index);

	fprintf(file, "serial_number        : \"%s\"\n", ptr_struct->serial_number);
	fprintf(file, "part_number          : \"%s\"\n", ptr_struct->part_number);
}

int mfnr_reg_size(void)
{
	return 44;
}

void mfnr_reg_dump(const struct mfnr_reg *ptr_struct, FILE *file)
{
	mfnr_reg_print(ptr_struct, file, 0);
}

void mfsl_reg_pack(const struct mfsl_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ie);

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ee);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tacho);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tach_min);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tach_max);

}

void mfsl_reg_unpack(struct mfsl_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->ie = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 28;
	ptr_struct->ee = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 4;
	ptr_struct->tacho = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->tach_min = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->tach_max = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void mfsl_reg_print(const struct mfsl_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mfsl_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ie                   : " UH_FMT "\n", ptr_struct->ie);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ee                   : " UH_FMT "\n", ptr_struct->ee);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tacho                : " UH_FMT "\n", ptr_struct->tacho);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tach_min             : " UH_FMT "\n", ptr_struct->tach_min);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tach_max             : " UH_FMT "\n", ptr_struct->tach_max);

}

int mfsl_reg_size(void)
{
	return 12;
}

void mfsl_reg_dump(const struct mfsl_reg *ptr_struct, FILE *file)
{
	mfsl_reg_print(ptr_struct, file, 0);
}

void mfsm_reg_pack(const struct mfsm_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tacho);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rpm);

}

void mfsm_reg_unpack(struct mfsm_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 4;
	ptr_struct->tacho = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->rpm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void mfsm_reg_print(const struct mfsm_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mfsm_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tacho                : " UH_FMT "\n", ptr_struct->tacho);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rpm                  : " UH_FMT "\n", ptr_struct->rpm);

}

int mfsm_reg_size(void)
{
	return 8;
}

void mfsm_reg_dump(const struct mfsm_reg *ptr_struct, FILE *file)
{
	mfsm_reg_print(ptr_struct, file, 0);
}

void mpein_reg_pack(const struct mpein_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->node);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pcie_index);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->depth);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->capability_mask);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->link_speed_enabled);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->link_width_enabled);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->link_speed_active);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->link_width_active);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->lane0_physical_position);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_of_vfs);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_of_pfs);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->bdf0);

	offset = 223;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lane_reversal);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_type);

	offset = 196;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->max_payload_size);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->max_read_request_size);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port_state);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->device_status);

	offset = 336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->receiver_detect_result);

}

void mpein_reg_unpack(struct mpein_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->node = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->pcie_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 2;
	ptr_struct->depth = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 32;
	ptr_struct->capability_mask = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 80;
	ptr_struct->link_speed_enabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 72;
	ptr_struct->link_width_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->link_speed_active = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 104;
	ptr_struct->link_width_active = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->lane0_physical_position = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->num_of_vfs = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->num_of_pfs = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->bdf0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 223;
	ptr_struct->lane_reversal = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 208;
	ptr_struct->port_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 196;
	ptr_struct->max_payload_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->max_read_request_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 304;
	ptr_struct->port_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 288;
	ptr_struct->device_status = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 336;
	ptr_struct->receiver_detect_result = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void mpein_reg_print(const struct mpein_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mpein_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "node                 : " UH_FMT "\n", ptr_struct->node);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_index           : " UH_FMT "\n", ptr_struct->pcie_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "depth                : " UH_FMT "\n", ptr_struct->depth);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "capability_mask      : " U32H_FMT "\n", ptr_struct->capability_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_speed_enabled   : " UH_FMT "\n", ptr_struct->link_speed_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_width_enabled   : " UH_FMT "\n", ptr_struct->link_width_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_speed_active    : " UH_FMT "\n", ptr_struct->link_speed_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_width_active    : " UH_FMT "\n", ptr_struct->link_width_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane0_physical_position : " UH_FMT "\n", ptr_struct->lane0_physical_position);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_vfs           : " UH_FMT "\n", ptr_struct->num_of_vfs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_pfs           : " UH_FMT "\n", ptr_struct->num_of_pfs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bdf0                 : " UH_FMT "\n", ptr_struct->bdf0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane_reversal        : " UH_FMT "\n", ptr_struct->lane_reversal);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_type            : " UH_FMT "\n", ptr_struct->port_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_payload_size     : " UH_FMT "\n", ptr_struct->max_payload_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_read_request_size : " UH_FMT "\n", ptr_struct->max_read_request_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_state           : " UH_FMT "\n", ptr_struct->port_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_status        : " UH_FMT "\n", ptr_struct->device_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "receiver_detect_result : " UH_FMT "\n", ptr_struct->receiver_detect_result);

}

int mpein_reg_size(void)
{
	return 44;
}

void mpein_reg_dump(const struct mpein_reg *ptr_struct, FILE *file)
{
	mpein_reg_print(ptr_struct, file, 0);
}

void mpir_reg_pack(const struct mpir_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->host_buses);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->node);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pcie_index);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->depth);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sdm);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->subordinate_bus);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->secondary_bus);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->device);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->bus);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 115;
	adb2c_push_bits_to_buff(ptr_buff, offset, 13, (u_int32_t)ptr_struct->slot_number);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->num_con_devices);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->slot_cap);

}

void mpir_reg_unpack(struct mpir_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->host_buses = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 16;
	ptr_struct->node = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->pcie_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 2;
	ptr_struct->depth = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 0;
	ptr_struct->sdm = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 56;
	ptr_struct->subordinate_bus = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->secondary_bus = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->device = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 72;
	ptr_struct->bus = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 115;
	ptr_struct->slot_number = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 13);

	offset = 104;
	ptr_struct->num_con_devices = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->slot_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void mpir_reg_print(const struct mpir_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mpir_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "host_buses           : " UH_FMT "\n", ptr_struct->host_buses);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "node                 : " UH_FMT "\n", ptr_struct->node);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_index           : " UH_FMT "\n", ptr_struct->pcie_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "depth                : " UH_FMT "\n", ptr_struct->depth);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sdm                  : " UH_FMT "\n", ptr_struct->sdm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "subordinate_bus      : " UH_FMT "\n", ptr_struct->subordinate_bus);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "secondary_bus        : " UH_FMT "\n", ptr_struct->secondary_bus);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device               : " UH_FMT "\n", ptr_struct->device);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bus                  : " UH_FMT "\n", ptr_struct->bus);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slot_number          : " UH_FMT "\n", ptr_struct->slot_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_con_devices      : " UH_FMT "\n", ptr_struct->num_con_devices);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slot_cap             : " UH_FMT "\n", ptr_struct->slot_cap);

}

int mpir_reg_size(void)
{
	return 16;
}

void mpir_reg_dump(const struct mpir_reg *ptr_struct, FILE *file)
{
	mpir_reg_print(ptr_struct, file, 0);
}

void msgi_reg_pack(const struct msgi_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 24; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1024, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->serial_number[i]);
	}

	for (i = 0; i < 20; i++) {
	offset = adb2c_calc_array_field_address(280, 8, i, 1024, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->part_number[i]);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(472, 8, i, 1024, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->revision[i]);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(504, 8, i, 1024, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->manufacturing_date[i]);
	}

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(536, 8, i, 1024, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->product_name[i]);
	}

}

void msgi_reg_unpack(struct msgi_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 24; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1024, 1);
	ptr_struct->serial_number[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->serial_number[24] = '\0';
	for (i = 0; i < 20; i++) {
	offset = adb2c_calc_array_field_address(280, 8, i, 1024, 1);
	ptr_struct->part_number[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->part_number[20] = '\0';
	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(472, 8, i, 1024, 1);
	ptr_struct->revision[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->revision[4] = '\0';
	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(504, 8, i, 1024, 1);
	ptr_struct->manufacturing_date[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->manufacturing_date[4] = '\0';
	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(536, 8, i, 1024, 1);
	ptr_struct->product_name[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->product_name[64] = '\0';
}

void msgi_reg_print(const struct msgi_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== msgi_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	fprintf(file, "serial_number        : \"%s\"\n", ptr_struct->serial_number);
	fprintf(file, "part_number          : \"%s\"\n", ptr_struct->part_number);
	fprintf(file, "revision             : \"%s\"\n", ptr_struct->revision);
	fprintf(file, "manufacturing_date   : \"%s\"\n", ptr_struct->manufacturing_date);
	fprintf(file, "product_name         : \"%s\"\n", ptr_struct->product_name);
}

int msgi_reg_size(void)
{
	return 128;
}

void msgi_reg_dump(const struct msgi_reg *ptr_struct, FILE *file)
{
	msgi_reg_print(ptr_struct, file, 0);
}

void msps_reg_pack(const struct msps_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	psu_status_pack(&(ptr_struct->psu0), ptr_buff + offset/8);

	offset = 640;
	psu_status_pack(&(ptr_struct->psu1), ptr_buff + offset/8);

}

void msps_reg_unpack(struct msps_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	psu_status_unpack(&(ptr_struct->psu0), ptr_buff + offset/8);

	offset = 640;
	psu_status_unpack(&(ptr_struct->psu1), ptr_buff + offset/8);

}

void msps_reg_print(const struct msps_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== msps_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psu0:\n");
	psu_status_print(&(ptr_struct->psu0), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psu1:\n");
	psu_status_print(&(ptr_struct->psu1), file, indent_level + 1);

}

int msps_reg_size(void)
{
	return 160;
}

void msps_reg_dump(const struct msps_reg *ptr_struct, FILE *file)
{
	msps_reg_print(ptr_struct, file, 0);
}

void mtcap_reg_pack(const struct mtcap_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->sensor_count);

}

void mtcap_reg_unpack(struct mtcap_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	ptr_struct->sensor_count = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

}

void mtcap_reg_print(const struct mtcap_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mtcap_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_count         : " UH_FMT "\n", ptr_struct->sensor_count);

}

int mtcap_reg_size(void)
{
	return 8;
}

void mtcap_reg_dump(const struct mtcap_reg *ptr_struct, FILE *file)
{
	mtcap_reg_print(ptr_struct, file, 0);
}

void mtmp_reg_pack(const struct mtmp_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->sensor_index);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_temperature);

	offset = 65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mtr);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mte);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature_threshold_hi);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->tee);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature_threshold_lo);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(216, 8, i, 256, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sensor_name_hi[i]);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(248, 8, i, 256, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sensor_name_lo[i]);
	}

}

void mtmp_reg_unpack(struct mtmp_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	ptr_struct->sensor_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 48;
	ptr_struct->temperature = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->max_temperature = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 65;
	ptr_struct->mtr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 64;
	ptr_struct->mte = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 112;
	ptr_struct->temperature_threshold_hi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->tee = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 144;
	ptr_struct->temperature_threshold_lo = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(216, 8, i, 256, 1);
	ptr_struct->sensor_name_hi[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->sensor_name_hi[4] = '\0';
	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(248, 8, i, 256, 1);
	ptr_struct->sensor_name_lo[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->sensor_name_lo[4] = '\0';
}

void mtmp_reg_print(const struct mtmp_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mtmp_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_index         : " UH_FMT "\n", ptr_struct->sensor_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature          : " UH_FMT "\n", ptr_struct->temperature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_temperature      : " UH_FMT "\n", ptr_struct->max_temperature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtr                  : " UH_FMT "\n", ptr_struct->mtr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mte                  : " UH_FMT "\n", ptr_struct->mte);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature_threshold_hi : " UH_FMT "\n", ptr_struct->temperature_threshold_hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tee                  : " UH_FMT "\n", ptr_struct->tee);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature_threshold_lo : " UH_FMT "\n", ptr_struct->temperature_threshold_lo);

	fprintf(file, "sensor_name_hi       : \"%s\"\n", ptr_struct->sensor_name_hi);
	fprintf(file, "sensor_name_lo       : \"%s\"\n", ptr_struct->sensor_name_lo);
}

int mtmp_reg_size(void)
{
	return 32;
}

void mtmp_reg_dump(const struct mtmp_reg *ptr_struct, FILE *file)
{
	mtmp_reg_print(ptr_struct, file, 0);
}

void mtwe_reg_pack(const struct mtwe_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sensor_warning0);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sensor_warning1);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sensor_warning2);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sensor_warning3);

}

void mtwe_reg_unpack(struct mtwe_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->sensor_warning0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->sensor_warning1 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->sensor_warning2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->sensor_warning3 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void mtwe_reg_print(const struct mtwe_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mtwe_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_warning0      : " U32H_FMT "\n", ptr_struct->sensor_warning0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_warning1      : " U32H_FMT "\n", ptr_struct->sensor_warning1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_warning2      : " U32H_FMT "\n", ptr_struct->sensor_warning2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_warning3      : " U32H_FMT "\n", ptr_struct->sensor_warning3);

}

int mtwe_reg_size(void)
{
	return 16;
}

void mtwe_reg_dump(const struct mtwe_reg *ptr_struct, FILE *file)
{
	mtwe_reg_print(ptr_struct, file, 0);
}

void mvcap_reg_pack(const struct mvcap_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->sensor_map);

}

void mvcap_reg_unpack(struct mvcap_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->sensor_map = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void mvcap_reg_print(const struct mvcap_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mvcap_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_map           : " U64H_FMT "\n", ptr_struct->sensor_map);

}

int mvcap_reg_size(void)
{
	return 16;
}

void mvcap_reg_dump(const struct mvcap_reg *ptr_struct, FILE *file)
{
	mvcap_reg_print(ptr_struct, file, 0);
}

void mvcr_reg_pack(const struct mvcr_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->sensor_index);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->voltage_sensor_value);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->current_sensor_value);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->sensor_name);

}

void mvcr_reg_unpack(struct mvcr_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	ptr_struct->sensor_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 48;
	ptr_struct->voltage_sensor_value = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->current_sensor_value = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->sensor_name = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void mvcr_reg_print(const struct mvcr_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mvcr_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_index         : " UH_FMT "\n", ptr_struct->sensor_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "voltage_sensor_value : " UH_FMT "\n", ptr_struct->voltage_sensor_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "current_sensor_value : " UH_FMT "\n", ptr_struct->current_sensor_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_name          : " U64H_FMT "\n", ptr_struct->sensor_name);

}

int mvcr_reg_size(void)
{
	return 24;
}

void mvcr_reg_dump(const struct mvcr_reg *ptr_struct, FILE *file)
{
	mvcr_reg_print(ptr_struct, file, 0);
}

void ppamp_reg_pack(const struct ppamp_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->opamp_group_type);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->opamp_group);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->num_of_indices);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->start_index);

	offset = 84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->max_num_of_indices);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->max_opamp_group);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(112, 16, i, 352, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->index_data[i]);
	}

}

void ppamp_reg_unpack(struct ppamp_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->opamp_group_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 8;
	ptr_struct->opamp_group = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 52;
	ptr_struct->num_of_indices = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 32;
	ptr_struct->start_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 84;
	ptr_struct->max_num_of_indices = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 72;
	ptr_struct->max_opamp_group = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(112, 16, i, 352, 1);
	ptr_struct->index_data[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

}

void ppamp_reg_print(const struct ppamp_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppamp_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opamp_group_type     : " UH_FMT "\n", ptr_struct->opamp_group_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opamp_group          : " UH_FMT "\n", ptr_struct->opamp_group);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_indices       : " UH_FMT "\n", ptr_struct->num_of_indices);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "start_index          : " UH_FMT "\n", ptr_struct->start_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_num_of_indices   : " UH_FMT "\n", ptr_struct->max_num_of_indices);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_opamp_group      : " UH_FMT "\n", ptr_struct->max_opamp_group);

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "index_data_%03d      : " UH_FMT "\n", i, ptr_struct->index_data[i]);
	}

}

int ppamp_reg_size(void)
{
	return 44;
}

void ppamp_reg_dump(const struct ppamp_reg *ptr_struct, FILE *file)
{
	ppamp_reg_print(ptr_struct, file, 0);
}

void ppll_reg_pack(const struct ppll_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->num_plls);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pll_group);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->num_pll_groups);

	offset = 63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ae);

	offset = 64;
	pll_status_pack(&(ptr_struct->pll_status0), ptr_buff + offset/8);

	offset = 128;
	pll_status_pack(&(ptr_struct->pll_status1), ptr_buff + offset/8);

	offset = 192;
	pll_status_pack(&(ptr_struct->pll_status2), ptr_buff + offset/8);

	offset = 256;
	pll_status_pack(&(ptr_struct->pll_status3), ptr_buff + offset/8);

}

void ppll_reg_unpack(struct ppll_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 20;
	ptr_struct->num_plls = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 8;
	ptr_struct->pll_group = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->num_pll_groups = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 63;
	ptr_struct->ae = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 64;
	pll_status_unpack(&(ptr_struct->pll_status0), ptr_buff + offset/8);

	offset = 128;
	pll_status_unpack(&(ptr_struct->pll_status1), ptr_buff + offset/8);

	offset = 192;
	pll_status_unpack(&(ptr_struct->pll_status2), ptr_buff + offset/8);

	offset = 256;
	pll_status_unpack(&(ptr_struct->pll_status3), ptr_buff + offset/8);

}

void ppll_reg_print(const struct ppll_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppll_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_plls             : " UH_FMT "\n", ptr_struct->num_plls);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_group            : " UH_FMT "\n", ptr_struct->pll_group);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_pll_groups       : " UH_FMT "\n", ptr_struct->num_pll_groups);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ae                   : " UH_FMT "\n", ptr_struct->ae);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_status0:\n");
	pll_status_print(&(ptr_struct->pll_status0), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_status1:\n");
	pll_status_print(&(ptr_struct->pll_status1), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_status2:\n");
	pll_status_print(&(ptr_struct->pll_status2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_status3:\n");
	pll_status_print(&(ptr_struct->pll_status3), file, indent_level + 1);

}

int ppll_reg_size(void)
{
	return 40;
}

void ppll_reg_dump(const struct ppll_reg *ptr_struct, FILE *file)
{
	ppll_reg_print(ptr_struct, file, 0);
}

void ptas_reg_pack(const struct ptas_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->num_of_repetitions);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->repetitions_mode);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->algorithm_options);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phase_grade_weight);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->height_grade_weight);

	offset = 76;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->phase_grade_type);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->height_grade_type);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->grade_version);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->adaptive_tap_measure_bits);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gisim_measure_bits);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ber_bath_mid_error_threshold);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ber_bath_high_error_threshold);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->one_ratio_high_threshold);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ber_bath_low_error_threshold);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->one_ratio_low_mid_threshold);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->one_ratio_high_mid_threshold);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ndeo_error_threshold);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->one_ratio_low_threshold);

	offset = 280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mix90_phase_for_voltage_bath);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mixer_offset_step_size);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mixer_offset_end);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mixer_offset_start);

	offset = 341;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->ber_test_time);

}

void ptas_reg_unpack(struct ptas_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 56;
	ptr_struct->num_of_repetitions = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 52;
	ptr_struct->repetitions_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->algorithm_options = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 88;
	ptr_struct->phase_grade_weight = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->height_grade_weight = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 76;
	ptr_struct->phase_grade_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 72;
	ptr_struct->height_grade_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->grade_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->adaptive_tap_measure_bits = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->gisim_measure_bits = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->ber_bath_mid_error_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->ber_bath_high_error_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 176;
	ptr_struct->one_ratio_high_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->ber_bath_low_error_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 208;
	ptr_struct->one_ratio_low_mid_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->one_ratio_high_mid_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 240;
	ptr_struct->ndeo_error_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->one_ratio_low_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 280;
	ptr_struct->mix90_phase_for_voltage_bath = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 256;
	ptr_struct->mixer_offset_step_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 304;
	ptr_struct->mixer_offset_end = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 288;
	ptr_struct->mixer_offset_start = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 341;
	ptr_struct->ber_test_time = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

}

void ptas_reg_print(const struct ptas_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ptas_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_repetitions   : " UH_FMT "\n", ptr_struct->num_of_repetitions);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "repetitions_mode     : " UH_FMT "\n", ptr_struct->repetitions_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "algorithm_options    : " UH_FMT "\n", ptr_struct->algorithm_options);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_grade_weight   : " UH_FMT "\n", ptr_struct->phase_grade_weight);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_grade_weight  : " UH_FMT "\n", ptr_struct->height_grade_weight);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_grade_type     : " UH_FMT "\n", ptr_struct->phase_grade_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_grade_type    : " UH_FMT "\n", ptr_struct->height_grade_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade_version        : " UH_FMT "\n", ptr_struct->grade_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adaptive_tap_measure_bits : " UH_FMT "\n", ptr_struct->adaptive_tap_measure_bits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gisim_measure_bits   : " UH_FMT "\n", ptr_struct->gisim_measure_bits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_bath_mid_error_threshold : " UH_FMT "\n", ptr_struct->ber_bath_mid_error_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_bath_high_error_threshold : " UH_FMT "\n", ptr_struct->ber_bath_high_error_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "one_ratio_high_threshold : " UH_FMT "\n", ptr_struct->one_ratio_high_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_bath_low_error_threshold : " UH_FMT "\n", ptr_struct->ber_bath_low_error_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "one_ratio_low_mid_threshold : " UH_FMT "\n", ptr_struct->one_ratio_low_mid_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "one_ratio_high_mid_threshold : " UH_FMT "\n", ptr_struct->one_ratio_high_mid_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ndeo_error_threshold : " UH_FMT "\n", ptr_struct->ndeo_error_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "one_ratio_low_threshold : " UH_FMT "\n", ptr_struct->one_ratio_low_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mix90_phase_for_voltage_bath : " UH_FMT "\n", ptr_struct->mix90_phase_for_voltage_bath);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset_step_size : " UH_FMT "\n", ptr_struct->mixer_offset_step_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset_end     : " UH_FMT "\n", ptr_struct->mixer_offset_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset_start   : " UH_FMT "\n", ptr_struct->mixer_offset_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_test_time        : " UH_FMT "\n", ptr_struct->ber_test_time);

}

int ptas_reg_size(void)
{
	return 44;
}

void ptas_reg_dump(const struct ptas_reg *ptr_struct, FILE *file)
{
	ptas_reg_print(ptr_struct, file, 0);
}

void slcct_reg_pack(const struct slcct_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->status);

	offset = 59;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->conf_index);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->num_of_idx);

	for (i = 0; i < 9; i++) {
	offset = adb2c_calc_array_field_address(64, 32, i, 352, 1);
	ctle_calib_set_pack(&(ptr_struct->ctle_calib_set[i]), ptr_buff + offset/8);
	}

}

void slcct_reg_unpack(struct slcct_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 59;
	ptr_struct->conf_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 52;
	ptr_struct->num_of_idx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	for (i = 0; i < 9; i++) {
	offset = adb2c_calc_array_field_address(64, 32, i, 352, 1);
	ctle_calib_set_unpack(&(ptr_struct->ctle_calib_set[i]), ptr_buff + offset/8);
	}

}

void slcct_reg_print(const struct slcct_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slcct_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "conf_index           : " UH_FMT "\n", ptr_struct->conf_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_idx           : " UH_FMT "\n", ptr_struct->num_of_idx);

	for (i = 0; i < 9; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctle_calib_set_%03d:\n", i);
	ctle_calib_set_print(&(ptr_struct->ctle_calib_set[i]), file, indent_level + 1);
	}

}

int slcct_reg_size(void)
{
	return 44;
}

void slcct_reg_dump(const struct slcct_reg *ptr_struct, FILE *file)
{
	slcct_reg_print(ptr_struct, file, 0);
}

void slreg_reg_pack(const struct slreg_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->eidx);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->status);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->eye_grade);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->initial_error);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->post_error);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->initial_area);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->post_area);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->post_area_after_centering);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gd_iter_num_error);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gd_iter_num_area);

	offset = 246;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->initial_sel_enc_slave);

	offset = 236;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->post_sel_enc_slave);

	offset = 226;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->post_sel_enc_slave_centering);

	offset = 278;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->rect_size);

	offset = 271;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->cur_phase_ib);

	offset = 258;
	adb2c_push_bits_to_buff(ptr_buff, offset, 13, (u_int32_t)ptr_struct->ffe_gain);

	offset = 319;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->init_all_gains_bad_value);

	offset = 318;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->update_single_gain_bad_value);

	offset = 317;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->monotonic_flow_height_inconsistent);

	offset = 316;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->monotonic_reached_high_limit);

	offset = 315;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->monotonic_reached_low_limit);

	offset = 307;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->area_zero_event_counter);

	offset = 299;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sel_enc_tune_area_failure);

}

void slreg_reg_unpack(struct slreg_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	ptr_struct->eidx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->eye_grade = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->initial_error = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->post_error = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->initial_area = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->post_area = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->post_area_after_centering = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 208;
	ptr_struct->gd_iter_num_error = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->gd_iter_num_area = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 246;
	ptr_struct->initial_sel_enc_slave = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 236;
	ptr_struct->post_sel_enc_slave = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 226;
	ptr_struct->post_sel_enc_slave_centering = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 278;
	ptr_struct->rect_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 271;
	ptr_struct->cur_phase_ib = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 258;
	ptr_struct->ffe_gain = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 13);

	offset = 319;
	ptr_struct->init_all_gains_bad_value = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 318;
	ptr_struct->update_single_gain_bad_value = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 317;
	ptr_struct->monotonic_flow_height_inconsistent = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 316;
	ptr_struct->monotonic_reached_high_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 315;
	ptr_struct->monotonic_reached_low_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 307;
	ptr_struct->area_zero_event_counter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 299;
	ptr_struct->sel_enc_tune_area_failure = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void slreg_reg_print(const struct slreg_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slreg_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eidx                 : " UH_FMT "\n", ptr_struct->eidx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eye_grade            : " UH_FMT "\n", ptr_struct->eye_grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "initial_error        : " UH_FMT "\n", ptr_struct->initial_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_error           : " U32H_FMT "\n", ptr_struct->post_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "initial_area         : " U32H_FMT "\n", ptr_struct->initial_area);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_area            : " U32H_FMT "\n", ptr_struct->post_area);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_area_after_centering : " U32H_FMT "\n", ptr_struct->post_area_after_centering);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gd_iter_num_error    : " UH_FMT "\n", ptr_struct->gd_iter_num_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gd_iter_num_area     : " UH_FMT "\n", ptr_struct->gd_iter_num_area);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "initial_sel_enc_slave : " UH_FMT "\n", ptr_struct->initial_sel_enc_slave);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_sel_enc_slave   : " UH_FMT "\n", ptr_struct->post_sel_enc_slave);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_sel_enc_slave_centering : " UH_FMT "\n", ptr_struct->post_sel_enc_slave_centering);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rect_size            : " UH_FMT "\n", ptr_struct->rect_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cur_phase_ib         : " UH_FMT "\n", ptr_struct->cur_phase_ib);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_gain             : " UH_FMT "\n", ptr_struct->ffe_gain);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "init_all_gains_bad_value : " UH_FMT "\n", ptr_struct->init_all_gains_bad_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "update_single_gain_bad_value : " UH_FMT "\n", ptr_struct->update_single_gain_bad_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "monotonic_flow_height_inconsistent : " UH_FMT "\n", ptr_struct->monotonic_flow_height_inconsistent);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "monotonic_reached_high_limit : " UH_FMT "\n", ptr_struct->monotonic_reached_high_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "monotonic_reached_low_limit : " UH_FMT "\n", ptr_struct->monotonic_reached_low_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "area_zero_event_counter : " UH_FMT "\n", ptr_struct->area_zero_event_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_enc_tune_area_failure : " UH_FMT "\n", ptr_struct->sel_enc_tune_area_failure);

}

int slreg_reg_size(void)
{
	return 40;
}

void slreg_reg_dump(const struct slreg_reg *ptr_struct, FILE *file)
{
	slreg_reg_print(ptr_struct, file, 0);
}

void slrg_reg_pack(const struct slrg_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->status);

	offset = 32;
	slrg_data_pack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void slrg_reg_unpack(struct slrg_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	slrg_data_unpack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void slrg_reg_print(const struct slrg_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrg_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_data:\n");
	slrg_data_print(&(ptr_struct->page_data), file, indent_level + 1);

}

int slrg_reg_size(void)
{
	return 40;
}

void slrg_reg_dump(const struct slrg_reg *ptr_struct, FILE *file)
{
	slrg_reg_print(ptr_struct, file, 0);
}

void slrip_reg_pack(const struct slrip_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->status);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->ib_sel);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap3);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap2);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap1);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap0);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap7);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap6);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap5);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap4);

	offset = 151;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->ffe_tap_en);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sel_enc0);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap8);

	offset = 184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixer_offset1);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixer_offset0);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sel_enc2);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sel_enc1);

	offset = 216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->saved1_mixer_offset0);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->saved1_sel_enc0);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->saved0_mixer_offset0);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->saved0_sel_enc0);

}

void slrip_reg_unpack(struct slrip_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->ib_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 88;
	ptr_struct->ffe_tap3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->ffe_tap2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->ffe_tap1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->ffe_tap0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 120;
	ptr_struct->ffe_tap7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->ffe_tap6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->ffe_tap5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->ffe_tap4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 151;
	ptr_struct->ffe_tap_en = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset = 136;
	ptr_struct->sel_enc0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->ffe_tap8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 184;
	ptr_struct->mixer_offset1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 176;
	ptr_struct->mixer_offset0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 168;
	ptr_struct->sel_enc2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 160;
	ptr_struct->sel_enc1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 216;
	ptr_struct->saved1_mixer_offset0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 208;
	ptr_struct->saved1_sel_enc0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 200;
	ptr_struct->saved0_mixer_offset0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->saved0_sel_enc0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void slrip_reg_print(const struct slrip_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrip_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_sel               : " UH_FMT "\n", ptr_struct->ib_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap3             : " UH_FMT "\n", ptr_struct->ffe_tap3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap2             : " UH_FMT "\n", ptr_struct->ffe_tap2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap1             : " UH_FMT "\n", ptr_struct->ffe_tap1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap0             : " UH_FMT "\n", ptr_struct->ffe_tap0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap7             : " UH_FMT "\n", ptr_struct->ffe_tap7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap6             : " UH_FMT "\n", ptr_struct->ffe_tap6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap5             : " UH_FMT "\n", ptr_struct->ffe_tap5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap4             : " UH_FMT "\n", ptr_struct->ffe_tap4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap_en           : " UH_FMT "\n", ptr_struct->ffe_tap_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_enc0             : " UH_FMT "\n", ptr_struct->sel_enc0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap8             : " UH_FMT "\n", ptr_struct->ffe_tap8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset1        : " UH_FMT "\n", ptr_struct->mixer_offset1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset0        : " UH_FMT "\n", ptr_struct->mixer_offset0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_enc2             : " UH_FMT "\n", ptr_struct->sel_enc2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_enc1             : " UH_FMT "\n", ptr_struct->sel_enc1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "saved1_mixer_offset0 : " UH_FMT "\n", ptr_struct->saved1_mixer_offset0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "saved1_sel_enc0      : " UH_FMT "\n", ptr_struct->saved1_sel_enc0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "saved0_mixer_offset0 : " UH_FMT "\n", ptr_struct->saved0_mixer_offset0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "saved0_sel_enc0      : " UH_FMT "\n", ptr_struct->saved0_sel_enc0);

}

int slrip_reg_size(void)
{
	return 28;
}

void slrip_reg_dump(const struct slrip_reg *ptr_struct, FILE *file)
{
	slrip_reg_print(ptr_struct, file, 0);
}

void slrp_reg_pack(const struct slrp_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->status);

	offset = 32;
	slrp_data_pack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void slrp_reg_unpack(struct slrp_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	slrp_data_unpack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void slrp_reg_print(const struct slrp_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrp_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_data:\n");
	slrp_data_print(&(ptr_struct->page_data), file, indent_level + 1);

}

int slrp_reg_size(void)
{
	return 40;
}

void slrp_reg_dump(const struct slrp_reg *ptr_struct, FILE *file)
{
	slrp_reg_print(ptr_struct, file, 0);
}

void sltp_reg_pack(const struct sltp_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->status);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ob_tap2);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ob_tap1);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ob_tap0);

	offset = 71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->polarity);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ob_bias);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ob_reg);

	offset = 108;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ob_preemp_mode);

}

void sltp_reg_unpack(struct sltp_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 88;
	ptr_struct->ob_tap2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->ob_tap1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->ob_tap0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 71;
	ptr_struct->polarity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 120;
	ptr_struct->ob_bias = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->ob_reg = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 108;
	ptr_struct->ob_preemp_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void sltp_reg_print(const struct sltp_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== sltp_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_tap2              : " UH_FMT "\n", ptr_struct->ob_tap2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_tap1              : " UH_FMT "\n", ptr_struct->ob_tap1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_tap0              : " UH_FMT "\n", ptr_struct->ob_tap0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "polarity             : " UH_FMT "\n", ptr_struct->polarity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_bias              : " UH_FMT "\n", ptr_struct->ob_bias);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_reg               : " UH_FMT "\n", ptr_struct->ob_reg);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_preemp_mode       : " UH_FMT "\n", ptr_struct->ob_preemp_mode);

}

int sltp_reg_size(void)
{
	return 20;
}

void sltp_reg_dump(const struct sltp_reg *ptr_struct, FILE *file)
{
	sltp_reg_print(ptr_struct, file, 0);
}

void PACKETS_INTERNAL_pack(const union PACKETS_INTERNAL *ptr_struct, u_int8_t *ptr_buff)
{
	ppamp_reg_pack(&(ptr_struct->ppamp_reg), ptr_buff);
}

void PACKETS_INTERNAL_unpack(union PACKETS_INTERNAL *ptr_struct, const u_int8_t *ptr_buff)
{
	ppamp_reg_unpack(&(ptr_struct->ppamp_reg), ptr_buff);
}

void PACKETS_INTERNAL_print(const union PACKETS_INTERNAL *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PACKETS_INTERNAL ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_LossyLinkConfig:\n");
	SMP_LossyLinkConfig_print(&(ptr_struct->SMP_LossyLinkConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VendorSpec_PhyConfig:\n");
	VendorSpec_PhyConfig_print(&(ptr_struct->VendorSpec_PhyConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_TemperatureSensing:\n");
	SMP_TemperatureSensing_print(&(ptr_struct->SMP_TemperatureSensing), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_PrivateLFT:\n");
	SMP_PrivateLFT_print(&(ptr_struct->SMP_PrivateLFT), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_PrivateLFT_Map:\n");
	SMP_PrivateLFTMap_print(&(ptr_struct->SMP_PrivateLFT_Map), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_PrivateLFTDef:\n");
	SMP_PrivateLFTDef_print(&(ptr_struct->SMP_PrivateLFTDef), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_PrivateLFTInfo:\n");
	SMP_PrivateLFTInfo_print(&(ptr_struct->SMP_PrivateLFTInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_PortSLToPrivateLFTMap:\n");
	SMP_PortSLToPrivateLFTMap_print(&(ptr_struct->SMP_PortSLToPrivateLFTMap), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Addr_212_255:\n");
	CableInfo_Payload_Addr_212_255_print(&(ptr_struct->CableInfo_Payload_Addr_212_255), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Addr_168_211:\n");
	CableInfo_Payload_Addr_168_211_print(&(ptr_struct->CableInfo_Payload_Addr_168_211), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Addr_128_167:\n");
	CableInfo_Payload_Addr_128_167_print(&(ptr_struct->CableInfo_Payload_Addr_128_167), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Addr_0_47:\n");
	CableInfo_Payload_Addr_0_47_print(&(ptr_struct->CableInfo_Payload_Addr_0_47), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Addr_48_79:\n");
	CableInfo_Payload_Addr_48_79_print(&(ptr_struct->CableInfo_Payload_Addr_48_79), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Addr_80_127:\n");
	CableInfo_Payload_Addr_80_127_print(&(ptr_struct->CableInfo_Payload_Addr_80_127), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Page_3_Addr_212_255:\n");
	CableInfo_Payload_Page_3_Addr_212_255_print(&(ptr_struct->CableInfo_Payload_Page_3_Addr_212_255), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Page_F0_Addr_128_171:\n");
	CableInfo_Payload_Page_F0_Addr_128_171_print(&(ptr_struct->CableInfo_Payload_Page_F0_Addr_128_171), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Page_E9_Addr_128_175:\n");
	CableInfo_Payload_Page_E9_Addr_128_175_print(&(ptr_struct->CableInfo_Payload_Page_E9_Addr_128_175), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Page_E9_Addr_176_211:\n");
	CableInfo_Payload_Page_E9_Addr_176_211_print(&(ptr_struct->CableInfo_Payload_Page_E9_Addr_176_211), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_MAD_AttrMod_CableInfo:\n");
	SMP_MAD_AttrMod_CableInfo_print(&(ptr_struct->SMP_MAD_AttrMod_CableInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_CableInfo:\n");
	SMP_CableInfo_print(&(ptr_struct->SMP_CableInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_SMP_AttrMod_EyeOpen:\n");
	SMP_MAD_AttrMod_EyeOpen_print(&(ptr_struct->MAD_SMP_AttrMod_EyeOpen), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_EyeOpen:\n");
	SMP_EyeOpen_print(&(ptr_struct->SMP_EyeOpen), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_ARLinearForwardingTable_SX:\n");
	SMP_ARLinearForwardingTable_SX_print(&(ptr_struct->SMP_ARLinearForwardingTable_SX), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_ARLinearForwardingTable:\n");
	SMP_ARLinearForwardingTable_print(&(ptr_struct->SMP_ARLinearForwardingTable), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_ARGroupTable:\n");
	SMP_ARGroupTable_print(&(ptr_struct->SMP_ARGroupTable), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DDPhysCounters:\n");
	DDPhysCounters_print(&(ptr_struct->DDPhysCounters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DDPCIPerfCounters:\n");
	DDPCIPerfCounters_print(&(ptr_struct->DDPCIPerfCounters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DDTroubleShootingInfo:\n");
	DDTroubleShootingInfo_print(&(ptr_struct->DDTroubleShootingInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DDOperationInfo:\n");
	DDOperationInfo_print(&(ptr_struct->DDOperationInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DDPhyInfo:\n");
	DDPhyInfo_print(&(ptr_struct->DDPhyInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DDModuleInfo:\n");
	DDModuleInfo_print(&(ptr_struct->DDModuleInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DDLinkDownInfo:\n");
	DDLinkDownInfo_print(&(ptr_struct->DDLinkDownInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DD_RS_Histograms:\n");
	DD_RS_Histograms_print(&(ptr_struct->DD_RS_Histograms), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DD_PLR_Counters:\n");
	DD_PLR_Counters_print(&(ptr_struct->DD_PLR_Counters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DD_PhyStatisticalCounters:\n");
	DD_PhyStatisticalCounters_print(&(ptr_struct->DD_PhyStatisticalCounters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DD_ZL_FEC_Counters:\n");
	DD_ZL_FEC_Counters_print(&(ptr_struct->DD_ZL_FEC_Counters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfcr_reg:\n");
	mfcr_reg_print(&(ptr_struct->mfcr_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfsm_reg:\n");
	mfsm_reg_print(&(ptr_struct->mfsm_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfsl_reg:\n");
	mfsl_reg_print(&(ptr_struct->mfsl_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fore_reg:\n");
	fore_reg_print(&(ptr_struct->fore_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfnr_reg:\n");
	mfnr_reg_print(&(ptr_struct->mfnr_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtcap_reg:\n");
	mtcap_reg_print(&(ptr_struct->mtcap_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtmp_reg:\n");
	mtmp_reg_print(&(ptr_struct->mtmp_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtwe_reg:\n");
	mtwe_reg_print(&(ptr_struct->mtwe_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mvcap_reg:\n");
	mvcap_reg_print(&(ptr_struct->mvcap_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mvcr_reg:\n");
	mvcr_reg_print(&(ptr_struct->mvcr_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msps_reg:\n");
	msps_reg_print(&(ptr_struct->msps_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msgi_reg:\n");
	msgi_reg_print(&(ptr_struct->msgi_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrg_reg:\n");
	slrg_reg_print(&(ptr_struct->slrg_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrp_reg:\n");
	slrp_reg_print(&(ptr_struct->slrp_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sltp_reg:\n");
	sltp_reg_print(&(ptr_struct->sltp_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ptas_reg:\n");
	ptas_reg_print(&(ptr_struct->ptas_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppll_reg:\n");
	ppll_reg_print(&(ptr_struct->ppll_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mpein_reg:\n");
	mpein_reg_print(&(ptr_struct->mpein_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mpir_reg:\n");
	mpir_reg_print(&(ptr_struct->mpir_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrip_reg:\n");
	slrip_reg_print(&(ptr_struct->slrip_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slreg_reg:\n");
	slreg_reg_print(&(ptr_struct->slreg_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slcct_reg:\n");
	slcct_reg_print(&(ptr_struct->slcct_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppamp_reg:\n");
	ppamp_reg_print(&(ptr_struct->ppamp_reg), file, indent_level + 1);

}

int PACKETS_INTERNAL_size(void)
{
	return 16777216;
}

void PACKETS_INTERNAL_dump(const union PACKETS_INTERNAL *ptr_struct, FILE *file)
{
	PACKETS_INTERNAL_print(ptr_struct, file, 0);
}

